/*	
 *	clipspr2.c
 *
 *	ȈՃXvCghCo`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Aug  2 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	  gk]XvCg`(sprite_draw2)gƁA3D`惂W[(clipren3.o,framds??.o)N܂B
 *	  gk]XvCg`̎gppx͒Ⴂ̂ŁA3D`惂W[NĂ܂̂邽߂ɁA
 *	  gk]XvCg`悾́Aʏ̃XvCg@\(sprite_draw)Ƃ͕ʂ̃W[ɕ܂B
 */
#include "clip.h"

/*****************************************************************************
 *	
 *****************************************************************************/

void
sprite_draw2(int x, int y, int sprno, int param, fixed scale_x, fixed scale_y, fixed rot)
{
	SPRITE_DRIVER* driver = &sprite_driver;
	RENDER* render = driver->render;
	//
	const SPRITE* sprite;
	TEXTURE* texture_save;
	fixed cos_rot;
	fixed sin_rot;
	fixed a00;
	fixed a01;
	fixed a10;
	fixed a11;
	fixed x03;
	fixed x12;
	fixed y01;
	fixed y23;
	fixed a00_x03;
	fixed a00_x12;
	fixed a01_y01;
	fixed a01_y23;
	fixed a10_x03;
	fixed a10_x12;
	fixed a11_y01;
	fixed a11_y23;
	VERTEX v[4];

	/* ̂߁Arender_save()g킸ɃeNX`ޔ܂B */
	texture_save = render->context->texture;

	/* XvCg擾܂B */
	if(sprno < 0 || driver->sprite_count - 1 < sprno) DIE();
	sprite = &driver->sprites[sprno];

	/* eNX`ݒ肵܂B */
	if(sprite->texno > driver->texture_count - 1) DIE();
	render->context->texture = &driver->textures[sprite->texno];

	/* XvCg`܂B */
	param ^= sprite->param;
	if(!(param & DRW_REVX)) {
		x03 = fiadd(fld(-0.5),         0 - sprite->cx);
		x12 = fiadd(fld(-0.5), sprite->w - sprite->cx);
	} else {
		x03 = fisub(fld( 0.5),         0 - sprite->cx);
		x12 = fisub(fld( 0.5), sprite->w - sprite->cx);
	}
	if(!(param & DRW_REVY)) {
		y01 = fiadd(fld(-0.5),         0 - sprite->cy);
		y23 = fiadd(fld(-0.5), sprite->h - sprite->cy);
	} else {
		y01 = fisub(fld( 0.5),         0 - sprite->cy);
		y23 = fisub(fld( 0.5), sprite->h - sprite->cy);
	}
	cos_rot = fcos(rot);
	sin_rot = fsin(rot);
	a00 = fmul(cos_rot, scale_x);
	a01 = fmul(sin_rot, scale_y);
	a10 = fmul(sin_rot, scale_x);
	a11 = fmul(cos_rot, scale_y);
	a00_x03 = fmul(a00, x03);
	a00_x12 = fmul(a00, x12);
	a01_y01 = fmul(a01, y01);
	a01_y23 = fmul(a01, y23);
	a10_x03 = fmul(a10, x03);
	a10_x12 = fmul(a10, x12);
	a11_y01 = fmul(a11, y01);
	a11_y23 = fmul(a11, y23);
	v[0].x = x + fist(fsub(a00_x03, a01_y01));
	v[0].y = y + fist(fadd(a10_x03, a11_y01));
	v[1].x = x + fist(fsub(a00_x12, a01_y01));
	v[1].y = y + fist(fadd(a10_x12, a11_y01));
	v[2].x = x + fist(fsub(a00_x12, a01_y23));
	v[2].y = y + fist(fadd(a10_x12, a11_y23));
	v[3].x = x + fist(fsub(a00_x03, a01_y23));
	v[3].y = y + fist(fadd(a10_x03, a11_y23));
	v[0].s = v[3].s = sprite->x;
	v[1].s = v[2].s = sprite->x + sprite->w - 1;
	v[0].t = v[1].t = sprite->y;
	v[2].t = v[3].t = sprite->y + sprite->h - 1;
	render_polygon(render, v, 4, 0);

	/* ̂߁Arender_restore()g킸ɃeNX`܂B */
	render->context->texture = texture_save;
}

