/*
 *	app.h
 *
 *	Vvbpbp
 *
 *	* Sun Apr 23 17:52:00 JST 2006 Naoyuki Sawa
 *	- 1st [XB
 */
#ifndef __APP_H__
#define __APP_H__

#include "supp/supp.h"
#include "spr.h"

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * - `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO -1 /*{{TODO}}*/

/* hFǂݍޏꍇ́AUSE_MUSICV{`ĂB
 * - USE_MUSICV{`ȂĂAyt[`͗p\łA
 *   hFst@CɒڃN邽߁At@CTCY傫Ȃ܂B
 */
//#define USE_MUSIC /*{{TODO}}*/

/* |[Y@\gꍇ́AUSE_PAUSEV{`ĂB */
#define USE_PAUSE /*{{TODO}}*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* L`sꍇ́AUSE_CHRV{`Ă */
//#define USE_CHR /*{{TODO}}*/
#ifdef USE_CHR
#define CHR_ CHR_INIT1
enum {
#include "chr.h"
};
extern const CHR chr_tbl[];
#undef CHR_
#endif /*USE_CHR*/

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	
 ****************************************************************************/

#define CELL_SIZE	8

#define FIELD_COLS	(14 + 2)
#define FIELD_ROWS	(13 + 2)

#define SCROLL_X_MIN	                                     (CELL_SIZE / 2)
#define SCROLL_Y_MIN	                                     (CELL_SIZE / 2)
#define SCROLL_X_MAX	                                     (CELL_SIZE / 2)
#define SCROLL_Y_MAX	((CELL_SIZE * FIELD_ROWS - DISP_Y) - (CELL_SIZE / 2))

#define DIR_LF		0
#define DIR_RI		1
#define DIR_UP		2
#define DIR_DN		3

#define SCORE_MAX	999999
#define LIFE_MAX	10		/* őc@ (݂̃vC[܂) */
#define PATTERN_MAX	(99 - 1)	/* 0x[X (\1x[X) */

/* PLAYER.stat,ENEMY.stat */
#define HT		0x80		/* 蔻L */

/* ړx */
#define CYMBOMB_SPD	fld(0.5)	/* Vo */
#define GUITACO_SPD	fld(0.75)	/* M^[() */
#define MADPHONE_SPD	fld(0.75)	/* wbhtH */
#define TRIEN_SPD	fld(1.0)	/* gCAO */
#define GUITARO_SPD	fld(1.5)	/* M^[() */
#define PIANHA_SPD	fld(1.5)	/* sAm */
#define RING_SPD	fld(1.5)	/* O (gCAO̍U) */
#define LAPAPA_SPD	fld(1.5)	/* vC[ */
#define FIRE_SPD	fild(CELL_SIZE)	/* U */

/* UԊu */
#define MADPHONE_ATTACK_MIN	 6	/* O */
#define MADPHONE_ATTACK_MAX	12
#define TRIEN_ATTACK_MIN	 8	/*  */
#define TRIEN_ATTACK_MAX	16
#define CYMBOMB_ATTACK_MIN	 8	/*  */
#define CYMBOM_ATTACK_MAX	16

/* ʉ */
#define SND_FIRE		3
#define SND_PLAYER_HIDE		1
#define SND_PLAYER_OUT		2
#define SND_ENEMY_OUT		0
#define SND_ATTACK		3
#define SND_ITEM		1
#define SND_ITEM_OUT		SND_ENEMY_OUT
#define SND_CLEAR		2

//
// * Ԍo߂ƃCxg̊Tv́A}̂ƂłB
//
//	 0 -+-	p^[JnA܂́AX^[gB
//	    |
//	    |
//	    |
//	    |
//	 5 -+-
//	    |
//	    |
//	    |
//	    |
//	10 -+-	ڂ̋xoB
//	    |	p^[xo񐔂͉ד܂ŁB
//	    |	ɓoĂAoȂB
//	    |	X^[gĂA׏o񐔂̓ZbgȂB
//	    |
//	15 -+-
//	    |
//	    |
//	    |
//	    |
//	20 -+-	ڂ̋xRŁB
//	    |
//	    |
//	    |
//	    |
//	25 -+-	ڂ̋xo
//	    |	p^[xo񐔂͉ד܂ŁB
//	    |	ɓoĂAoȂB
//	    |	X^[gĂA׏o񐔂̓ZbgȂB
//	    |
//	30 -+-	ǉ̓GoB								---
//	    |										 A
//	    |	M^[()=>()ɕωB						 |
//	    |	ړԈȊO͌oߎԂɊ܂߂Ȃ̂ŁA30bxB	 |
//	    |										 |	̊Ԃ̂ǂŃGNXgoB\bɎRŁB
//	35 -+-	ڂ̋xRŁB							 |	p^[GNXgo񐔂͉׈܂ŁB
//	    |										 |	X^[gĂA׏o񐔂̓ZbgȂB
//	    										 |
//	    										 |
//	    |										 V
//	60 -+-										---
//	    |
//	    
//	    
//
#define ENEMY_EXTRA_TIME	SEC(30)	/* X^[g`ǉ̓Go܂ł́Aoߎ */
#define GUITACO_GUITARO_TIME	SEC(30)	/* M^[()=>()ɕω܂ł́AړԎ */

#define STOP_SETUP_TIME_1	SEC(10)	/* X^[g`ڂ̋xo܂ł́Aoߎ */
#define STOP_SETUP_TIME_2	SEC(15)	/* ڂ̋xo`ڂ̋xo܂ł́Aoߎ */
#define STOP_CLEAR_TIME		SEC(10)	/* xo`Rł܂ł́Aoߎ */

#define EXTRA_SETUP_TIME_MIN	SEC(30)	/* X^[g`GNXgo܂ł́AŒZoߎ */
#define EXTRA_SETUP_TIME_MAX	SEC(60)	/* X^[g`GNXgo܂ł́AŒoߎ */
#define EXTRA_CLEAR_TIME	SEC(10)	/* GNXgo`Rł܂ł́Aoߎ */

/****************************************************************************
 *	
 ****************************************************************************/

/* CELL.stat */
#define CELL_STAT_NOTE		1	/* L */
#define CELL_STAT_TRAP		2	/* 㩗L */
#define CELL_STAT_STOP		3	/* xo */
#define CELL_STAT_EXTRA		4	/* GNXgo */
#define CELL_STAT_ERASE		5	/* xAGNXgŃGtFNg */

/* CELL.road */
#define CELL_ROAD_LF	(1<<DIR_LF)	/* ܐLAɂܐL */
#define CELL_ROAD_RI	(1<<DIR_RI)	/* ܐLAEɂܐL */
#define CELL_ROAD_UP	(1<<DIR_UP)	/* ܐLAɂܐL */
#define CELL_ROAD_DN	(1<<DIR_DN)	/* ܐLAɂܐL */

typedef struct _CELL {
	unsigned char stat;		/* 0A܂́ACELL_STAT_*I */
	unsigned char road;		/* CELL_ROAD_*́A0ȏ̑gݍ킹 */
	short cnt;			/* ėpJE^ */
} CELL;

/****************************************************************************
 *	vC[
 ****************************************************************************/

/* PLAYER.stat */
//				    0	/* o */
#define PLAYER_STAT_MOVE	(HT|1)	/* ʏ */
#define PLAYER_STAT_HIDE	    2	/*  */
#define PLAYER_STAT_STOP	(HT|3)	/* xzݒ */
#define PLAYER_STAT_EXTRA	(HT|4)	/* GNXgzݒ */
#define PLAYER_STAT_DIE		    5	/* AEg */

typedef struct _PLAYER {
	int stat;			/*  */
	int cnt;			/* ėpJE^ */

	int col;			/* ʒu [Z] */
	int row;			/* sʒu [Z] */
	int dir;			/*  (DIR_*) */
	fixed pos;			/* ړJE^ */
} PLAYER;

/****************************************************************************
 *	U
 ****************************************************************************/

typedef struct _FIRE {
	int active;			/* 0 = , 1 = gp */

	int col;			/* ʒu [Z] */
	int row;			/* sʒu [Z] */
	int dir;			/*  (DIR_*) */
	fixed pos;			/* ړJE^ */
} FIRE;

#define FIRE_MAX		8	/* Uo */

/****************************************************************************
 *	G
 ****************************************************************************/

/* ENEMY.type */
//				0	/*  */
#define ENEMY_TYPE_GUITACO	1	/* M^[() */
#define ENEMY_TYPE_GUITARO	2	/* M^[() */
#define ENEMY_TYPE_MADPHONE	3	/* wbhtH */
#define ENEMY_TYPE_TRIEN	4	/* gCAO */
#define ENEMY_TYPE_CYMBOMB	5	/* Vo */
#define ENEMY_TYPE_PIANHA	6	/* sAm */

/* ENEMY.stat */
//				    0	/* o */
#define ENEMY_STAT_SETUP	    1	/* o */
#define ENEMY_STAT_MOVE		(HT|2)	/* ʏ */
#define ENEMY_STAT_CHANGE	(HT|3)	/* M^[()=>() */
#define ENEMY_STAT_DIE		    4	/* AEg */
#define ENEMY_STAT_PTS		    5	/* |Cg\ */

typedef struct _ENEMY {
	int type;			/*  */
	int stat;			/*  */
	int cnt;			/* ėpJE^ */
	int weak;			/* ̉JE^ */
	int attack;			/* UJE^ */
	int change;			/* ʏԂł̌oߎ (M^[ϐgp) */

	int col;			/* ʒu [Z] */
	int row;			/* sʒu [Z] */
	int dir;			/*  (DIR_*) */
	fixed pos;			/* ړJE^ */

	int pts;			/* |Cg */
} ENEMY;

#define ENEMY_MAX		6	/* Go̍ől */
#define ENEMY_INIT_MAX		4	/* Goʒu̐ */

/****************************************************************************
 *	O (wbhtH̍U)
 ****************************************************************************/

typedef struct _RING {
	int active;			/* 0 = , 1 = gp */

	int col;			/* ʒu [Z] */
	int row;			/* sʒu [Z] */
	int dir;			/*  (DIR_*) */
	fixed pos;			/* ړJE^ */
} RING;

#define RING_MAX		8	/* Uo */

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _GAME {
	int score;				/* XRA */
	int life;				/* c@ (݂̃vC[܂) */
	int pattern;				/* p^[ԍ (0`) */

	int elapse;				/* X^[g_̌oߎ */
	int stop_pts;				/* xɂXRAZl */

	int scroll_x;				/* XN[XW [sNZ] */
	int scroll_y;				/* XN[YW [sNZ] */

	PLAYER player;				/* vC[ */

	FIRE fire[FIRE_MAX];			/* U */

	ENEMY enemy[ENEMY_MAX];			/* G */
	int i_enemy_init;			/* ̓GoʒuCfNX */

	RING ring[RING_MAX];			/* O */

	int stop_count;				/* ݂̃p^[ɂxco */
	int stop_setup_time;			/* xo܂ł̃JEg_E^C} */
	int stop_clear_time;			/* xRł܂ł̃JEg_E^C} */

	int extra_count;			/* ݂̃p^[ɂGNXgco */
	int extra_setup_time;			/* GNXgo܂ł̃JEg_E^C} */
	int extra_clear_time;			/* GNXgRł܂ł̃JEg_E^C} */

	/*{{p^[f[^擾*/
	int weak_time;				/* ̉ */
	int player_init_col;			/* vC[oʒu [Z] */
	int player_init_row;			/* vC[osʒu [Z] */
	int enemy_init_col[ENEMY_INIT_MAX];	/* Goʒu [Z] */
	int enemy_init_row[ENEMY_INIT_MAX];	/* Goʒu [Z] */
	int stop_init_col;			/* xoʒu [Z] */
	int stop_init_row;			/* xoʒu [Z] */
	int extra_init_col;			/* GNXgoʒu [Z] */
	int extra_init_row;			/* GNXgoʒu [Z] */
	CELL field[FIELD_ROWS][FIELD_COLS];
	/*}}p^[f[^擾*/
} GAME;

/****************************************************************************
 *	
 ****************************************************************************/

/* * Xe[Wf[^ƃp^[f[^̑gݍ킹́AȉɎƂłB
 *
 *	ð		ܐ		l
 *	-----	-----	------	----	-----------------------------------------
 *	' '	' '		
 *	' '	'.'		L
 *	'#'	'#'	L	
 *	'#'	'o'	L	L
 *	'@'	'#'	L		vC[oʒu (Tڂł)
 *	'@'	'o'	L	L	vC[oʒu (Tڂł)
 *	'x'	' '			Goʒu         (Tڂł)
 *	's'	' '			xoʒu       (Tڂł)
 *
 * - ɋȊȎgݍ킹́Asf[^ƌȂ܂B
 *   NɑSf[^Asf[^𔭌AG[\ďI܂B
 *
 * - ep^[ɂ͕KA4̓GoʒuƁA1̋xoʒu΂܂B
 *   Ȃ΁Asf[^ƌȂ܂B
 *
 * - GNXgoʒúAʒuɏo邱Ƃ̂łA܂ɈႤʒuɏo܂B
 *   @킩Ȃ̂ŁA{vOł́A擾\Ń_Ȉʒuɏo邱Ƃɂ܂B
 *   擾\Ń_ȈʒuƂ́AܐɗאڂĂāAAxAGoʒułȂẐƂłB
 */
#define STAGE_COUNT	8
extern const char stage_table[STAGE_COUNT][(FIELD_COLS - 2) * (FIELD_ROWS - 2) + 1/*nul*/];
#define PATTERN_COUNT	24
extern const char pattern_table[PATTERN_COUNT][(FIELD_COLS - 2) * (FIELD_ROWS - 2) + 1/*nul*/];

/* * ep^[ɏoAGL̎ނ̃XgłB
 * - 4+1ށA܂́A5+1ނ̍\łB
 *   Ō1ނ́Aep^[̊Jn莞ԌoߌɏoG̎ނłB
 */
extern const char enemy_table[PATTERN_COUNT][ENEMY_MAX];

/* * ep^[ɂāAxƂ́AG̎̉ԂłB(M^[()͒~̂)
 * - pattern_init()ɂĎQƂAGAME.weak_timeɊi[܂B
 *   pattern_init()ȊȌ́Aweak_time_table[]𒼐ڎQƂȂłB
 */
extern const int weak_time_table[PATTERN_COUNT];

/****************************************************************************
 *	
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void delay(int frame);
int demo_main();
void game_main();
void game_disp();

void score_add(int pts);
int get_stage();
int get_pattern();
void game_init();
void pattern_init();
void restart_init();

void get_xy(int col, int row, int dir, fixed pos, int* px, int* py);

void field_scroll(int init);
int field_action();
void field_disp();

void player_set_stat(int stat);
void player_action();
void player_disp();

void fire_gen(int col, int row, int dir);
void fire_action();
void fire_disp();

void enemy_set_stat(ENEMY* enemy, int stat);
void enemy_setup();
void enemy_action();
void enemy_disp();

void ring_gen(int col, int row, int dir);
void ring_action();
void ring_disp();

void ht_fire_enemy();
void ht_ring_player();
void ht_trap_player();
void ht_enemy_player();

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
