/*
 *	main.c
 *
 *	Vvbpbp
 *
 *	* Sun Apr 23 17:52:00 JST 2006 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_CHR
#define CHR_ CHR_INIT2
const CHR chr_tbl[] = {
#include "chr.h"
};
#undef CHR_
#endif /*USE_CHR*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	
 ****************************************************************************/

static const unsigned char ptn_road[3/*stat*/][16/*road*/] = {
	{SPR_ROAD     ,SPR_ROAD_Lxxx,SPR_ROAD_xRxx,SPR_ROAD_LRxx,SPR_ROAD_xxUx,SPR_ROAD_LxUx,SPR_ROAD_xRUx,SPR_ROAD_LRUx,SPR_ROAD_xxxD,SPR_ROAD_LxxD,SPR_ROAD_xRxD,SPR_ROAD_LRxD,SPR_ROAD_xxUD,SPR_ROAD_LxUD,SPR_ROAD_xRUD,SPR_ROAD_LRUD},
	{SPR_NOTE     ,SPR_NOTE_Lxxx,SPR_NOTE_xRxx,SPR_NOTE_LRxx,SPR_NOTE_xxUx,SPR_NOTE_LxUx,SPR_NOTE_xRUx,SPR_NOTE_LRUx,SPR_NOTE_xxxD,SPR_NOTE_LxxD,SPR_NOTE_xRxD,SPR_NOTE_LRxD,SPR_NOTE_xxUD,SPR_NOTE_LxUD,SPR_NOTE_xRUD,SPR_NOTE_LRUD},
	{SPR_TRAP     ,SPR_TRAP_Lxxx,SPR_TRAP_xRxx,SPR_TRAP_LRxx,SPR_TRAP_xxUx,SPR_TRAP_LxUx,SPR_TRAP_xRUx,SPR_TRAP_LRUx,SPR_TRAP_xxxD,SPR_TRAP_LxxD,SPR_TRAP_xRxD,SPR_TRAP_LRxD,SPR_TRAP_xxUD,SPR_TRAP_LxUD,SPR_TRAP_xRUD,SPR_TRAP_LRUD},
};
static const unsigned char ptn_stop[5] = {SPR_STOP,SPR_STOP_L,SPR_STOP_R,SPR_STOP_U,SPR_STOP_D};
static const unsigned char ptn_extra[5] = {SPR_EXTRA,SPR_EXTRA_L,SPR_EXTRA_R,SPR_EXTRA_U,SPR_EXTRA_D};

//static const unsigned char ptn_erase[2] = {SPR_ERASE_1,SPR_ERASE_2};
static const unsigned char ptn_erase[/*cnt*/] = {SPR_ERASE_1,SPR_ERASE_1,SPR_ERASE_2,SPR_ERASE_2};

static const CHR chr_start = {SPR_START,14,1};
static const CHR chr_pattern_no = {SPR_START,8,1};

static const unsigned char ptn_lapapa[4/*dir*/][6/*anim*/] = {
	{SPR_LAPAPA_L1,SPR_LAPAPA_L2,SPR_LAPAPA_L3,SPR_LAPAPA_L4,SPR_LAPAPA_L5,SPR_LAPAPA_L6},
	{SPR_LAPAPA_R1,SPR_LAPAPA_R2,SPR_LAPAPA_R3,SPR_LAPAPA_R4,SPR_LAPAPA_R5,SPR_LAPAPA_R6},
	{SPR_LAPAPA_U1,SPR_LAPAPA_U2,SPR_LAPAPA_U3,SPR_LAPAPA_U4,SPR_LAPAPA_U5,SPR_LAPAPA_U6},
	{SPR_LAPAPA_D1,SPR_LAPAPA_D2,SPR_LAPAPA_D3,SPR_LAPAPA_D4,SPR_LAPAPA_D5,SPR_LAPAPA_D6},
};
static const unsigned char ptn_lapapa_hide[4/*dir*/][20/*anim*/] = {
	{SPR_LAPAPA_L3,SPR_LAPAPA_L3,SPR_LAPAPA_L4,SPR_LAPAPA_L4,SPR_LAPAPA_L5,SPR_LAPAPA_L5,SPR_LAPAPA_L6,SPR_LAPAPA_L6,SPR_LAPAPA_L6,SPR_LAPAPA_L6,SPR_LAPAPA_L6,SPR_LAPAPA_L6,SPR_LAPAPA_L6,SPR_LAPAPA_L6,SPR_LAPAPA_L5,SPR_LAPAPA_L5,SPR_LAPAPA_L4,SPR_LAPAPA_L4,SPR_LAPAPA_L3,SPR_LAPAPA_L3},
	{SPR_LAPAPA_R3,SPR_LAPAPA_R3,SPR_LAPAPA_R4,SPR_LAPAPA_R4,SPR_LAPAPA_R5,SPR_LAPAPA_R5,SPR_LAPAPA_R6,SPR_LAPAPA_R6,SPR_LAPAPA_R6,SPR_LAPAPA_R6,SPR_LAPAPA_R6,SPR_LAPAPA_R6,SPR_LAPAPA_R6,SPR_LAPAPA_R6,SPR_LAPAPA_R5,SPR_LAPAPA_R5,SPR_LAPAPA_R4,SPR_LAPAPA_R4,SPR_LAPAPA_R3,SPR_LAPAPA_R3},
	{SPR_LAPAPA_U3,SPR_LAPAPA_U3,SPR_LAPAPA_U4,SPR_LAPAPA_U4,SPR_LAPAPA_U5,SPR_LAPAPA_U5,SPR_LAPAPA_U6,SPR_LAPAPA_U6,SPR_LAPAPA_U6,SPR_LAPAPA_U6,SPR_LAPAPA_U6,SPR_LAPAPA_U6,SPR_LAPAPA_U6,SPR_LAPAPA_U6,SPR_LAPAPA_U5,SPR_LAPAPA_U5,SPR_LAPAPA_U4,SPR_LAPAPA_U4,SPR_LAPAPA_U3,SPR_LAPAPA_U3},
	{SPR_LAPAPA_D3,SPR_LAPAPA_D3,SPR_LAPAPA_D4,SPR_LAPAPA_D4,SPR_LAPAPA_D5,SPR_LAPAPA_D5,SPR_LAPAPA_D6,SPR_LAPAPA_D6,SPR_LAPAPA_D6,SPR_LAPAPA_D6,SPR_LAPAPA_D6,SPR_LAPAPA_D6,SPR_LAPAPA_D6,SPR_LAPAPA_D6,SPR_LAPAPA_D5,SPR_LAPAPA_D5,SPR_LAPAPA_D4,SPR_LAPAPA_D4,SPR_LAPAPA_D3,SPR_LAPAPA_D3},
};
static const unsigned char ptn_lapapa_die[/*cnt*/] = {
	SPR_LAPAPA_L1,SPR_LAPAPA_L1,
	SPR_LAPAPA_U1,SPR_LAPAPA_U1,
	SPR_LAPAPA_R1,SPR_LAPAPA_R1,
	SPR_LAPAPA_D1,SPR_LAPAPA_D1,
	SPR_LAPAPA_L1,SPR_LAPAPA_L1,
	SPR_LAPAPA_U1,SPR_LAPAPA_U1,
	SPR_LAPAPA_R1,SPR_LAPAPA_R1,
	SPR_LAPAPA_D1,SPR_LAPAPA_D1,
	SPR_LAPAPA_L1,SPR_LAPAPA_L1,
	SPR_LAPAPA_U1,SPR_LAPAPA_U1,
	SPR_LAPAPA_R1,SPR_LAPAPA_R1,
	SPR_LAPAPA_D1,SPR_LAPAPA_D1,
	SPR_DIE_1,SPR_DIE_1,
	SPR_DIE_2,SPR_DIE_2,
	SPR_BLANK, /* AEgAj[VIfBCɁA\sȂ߂ɕKv */
};

static const unsigned char ptn_enemy[7/*type*/][4/*dir*/][2/*anim*/] = {
	{/*type=0͎g܂*/},
	{{SPR_GUITACO_L1, SPR_GUITACO_L2 },{SPR_GUITACO_R1, SPR_GUITACO_R2 },{SPR_GUITACO_U1, SPR_GUITACO_U2 },{SPR_GUITACO_D1, SPR_GUITACO_D2 }},
	{{SPR_GUITARO_L1, SPR_GUITARO_L2 },{SPR_GUITARO_R1, SPR_GUITARO_R2 },{SPR_GUITARO_U1, SPR_GUITARO_U2 },{SPR_GUITARO_D1, SPR_GUITARO_D2 }},
	{{SPR_MADPHONE_L1,SPR_MADPHONE_L2},{SPR_MADPHONE_R1,SPR_MADPHONE_R2},{SPR_MADPHONE_U1,SPR_MADPHONE_U2},{SPR_MADPHONE_D1,SPR_MADPHONE_D2}},
	{{SPR_TRIEN_L1,   SPR_TRIEN_L2   },{SPR_TRIEN_R1,   SPR_TRIEN_R2   },{SPR_TRIEN_U1,   SPR_TRIEN_U2   },{SPR_TRIEN_D1,   SPR_TRIEN_D2   }},
	{{SPR_CYMBOMB_L1, SPR_CYMBOMB_L2 },{SPR_CYMBOMB_R1, SPR_CYMBOMB_R2 },{SPR_CYMBOMB_U1, SPR_CYMBOMB_U2 },{SPR_CYMBOMB_D1, SPR_CYMBOMB_D2 }},
	{{SPR_PIANHA_L1,  SPR_PIANHA_L2  },{SPR_PIANHA_R1,  SPR_PIANHA_R2  },{SPR_PIANHA_U1,  SPR_PIANHA_U2  },{SPR_PIANHA_D1,  SPR_PIANHA_D2  }},
};
static const unsigned char ptn_enemy_die[7/*type*/][12/*anim*/] = {
	{/*type=0͎g܂*/},
	{SPR_GUITACO_L1, SPR_GUITACO_U1, SPR_GUITACO_R1, SPR_GUITACO_D1, SPR_GUITACO_L1, SPR_GUITACO_U1, SPR_GUITACO_R1, SPR_GUITACO_D1, SPR_DIE_1,SPR_DIE_1,SPR_DIE_2,SPR_DIE_2},
	{SPR_GUITARO_L1, SPR_GUITARO_U1, SPR_GUITARO_R1, SPR_GUITARO_D1, SPR_GUITARO_L1, SPR_GUITARO_U1, SPR_GUITARO_R1, SPR_GUITARO_D1, SPR_DIE_1,SPR_DIE_1,SPR_DIE_2,SPR_DIE_2},
	{SPR_MADPHONE_L1,SPR_MADPHONE_U1,SPR_MADPHONE_R1,SPR_MADPHONE_D1,SPR_MADPHONE_L1,SPR_MADPHONE_U1,SPR_MADPHONE_R1,SPR_MADPHONE_D1,SPR_DIE_1,SPR_DIE_1,SPR_DIE_2,SPR_DIE_2},
	{SPR_TRIEN_L1,   SPR_TRIEN_U1,   SPR_TRIEN_R1,   SPR_TRIEN_D1,   SPR_TRIEN_L1,   SPR_TRIEN_U1,   SPR_TRIEN_R1,   SPR_TRIEN_D1,   SPR_DIE_1,SPR_DIE_1,SPR_DIE_2,SPR_DIE_2},
	{SPR_CYMBOMB_L1, SPR_CYMBOMB_U1, SPR_CYMBOMB_R1, SPR_CYMBOMB_D1, SPR_CYMBOMB_L1, SPR_CYMBOMB_U1, SPR_CYMBOMB_R1, SPR_CYMBOMB_D1, SPR_DIE_1,SPR_DIE_1,SPR_DIE_2,SPR_DIE_2},
	{SPR_PIANHA_L1,  SPR_PIANHA_U1,  SPR_PIANHA_R1,  SPR_PIANHA_D1,  SPR_PIANHA_L1,  SPR_PIANHA_U1,  SPR_PIANHA_R1,  SPR_PIANHA_D1,  SPR_DIE_1,SPR_DIE_1,SPR_DIE_2,SPR_DIE_2},
};

//static const unsigned char ptn_setup[4] = {SPR_SETUP_1,SPR_SETUP_2,SPR_SETUP_3,SPR_SETUP_4};
static const unsigned char ptn_setup[/*cnt*/] = {
	SPR_SETUP_1,SPR_SETUP_2,SPR_SETUP_3,SPR_SETUP_2,
	SPR_SETUP_1,SPR_SETUP_2,SPR_SETUP_3,SPR_SETUP_2,
	SPR_SETUP_1,SPR_SETUP_2,SPR_SETUP_3,SPR_SETUP_2,
	SPR_SETUP_1,SPR_SETUP_2,SPR_SETUP_3,SPR_SETUP_2,
	SPR_SETUP_1,SPR_SETUP_2,SPR_SETUP_3,SPR_SETUP_2,
	SPR_SETUP_1,SPR_SETUP_2,SPR_SETUP_3,SPR_SETUP_4,
};
static const unsigned char ptn_weak[2] = {SPR_WEAK_1,SPR_WEAK_2};
static const unsigned char ptn_die[2] = {SPR_DIE_1,SPR_DIE_2};

static const unsigned char ptn_ring[] = {SPR_SETUP_2,SPR_SETUP_3,SPR_SETUP_4,SPR_SETUP_4,SPR_SETUP_3};

static const unsigned char ptn_change[4/*dir*/][12/*cnt*/] = {
	{SPR_GUITARO_L1,SPR_GUITARO_L1,SPR_GUITARO_L1,SPR_GUITACO_L1,SPR_GUITACO_L1,SPR_GUITACO_L1,SPR_GUITARO_L1,SPR_GUITARO_L1,SPR_GUITARO_L1,SPR_GUITACO_L1,SPR_GUITACO_L1,SPR_GUITACO_L1},
	{SPR_GUITARO_R1,SPR_GUITARO_R1,SPR_GUITARO_R1,SPR_GUITACO_R1,SPR_GUITACO_R1,SPR_GUITACO_R1,SPR_GUITARO_R1,SPR_GUITARO_R1,SPR_GUITARO_R1,SPR_GUITACO_R1,SPR_GUITACO_R1,SPR_GUITACO_R1},
	{SPR_GUITARO_U1,SPR_GUITARO_U1,SPR_GUITARO_U1,SPR_GUITACO_U1,SPR_GUITACO_U1,SPR_GUITACO_U1,SPR_GUITARO_U1,SPR_GUITARO_U1,SPR_GUITARO_U1,SPR_GUITACO_U1,SPR_GUITACO_U1,SPR_GUITACO_U1},
	{SPR_GUITARO_D1,SPR_GUITARO_D1,SPR_GUITARO_D1,SPR_GUITACO_D1,SPR_GUITACO_D1,SPR_GUITACO_D1,SPR_GUITARO_D1,SPR_GUITARO_D1,SPR_GUITARO_D1,SPR_GUITACO_D1,SPR_GUITACO_D1,SPR_GUITACO_D1},
};

static const CHR chr_title = {SPR_TITLE,10,3,0,0};

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
#ifdef USE_MUSIC
	/* hFǂݍ݂܂B */
	{
		int retval;
		thread_lock();
		retval = loadInst();
		thread_unlock();
		if(retval != 0) {
			grcls(3);
			symbol(4, 34, "drum.arcǂݍݎsł", 0, 0);
			symbol(4, 44, "h͍Đ܂", 0, 0);
			wait(3000);
			grcls(-1);
		}
	}
#endif /*USE_MUSIC*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */		// vC[,vC[U,G,GU
		 1,	/* 1:eLXg\/0:\ */		// ܐ,ܐ+,wiF
		 1,	/* 1:OtBbN\/0:\ */	// XRA
		 0,	/* 1:eLXgO/0:w */		// OtBbNXvCgeLXg
		 0);	/* wiF(wʕ\Ȃ̂) */	// (g܂)

	/* p^[f[^܂B */
	for(game.pattern = 0; game.pattern < PATTERN_COUNT; game.pattern++) {
		pattern_init();
	}
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int joy_old, trg;

#ifdef USE_PAUSE
	{
		int pause = 0;
		for(;;) {
#endif /*USE_PAUSE */

			/* [VSYNC҂B */
			if(prev == 0) prev = msec();
			do {
				cur = msec();
			} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
			prev = cur;

			/* pbhԎ擾B
			 * - VvCuł́AgK̔ōsKv܂B
			 */
			joy_old = joy;
			joy = pad() & 0x00ff;
			trg = (joy ^ joy_old) & joy;
			joy |= trg << 8;

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause; /* PAUSEԐ؂ւ */
				if(!pause) pausedisp(0);
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(msec() % 1000 < 750) {
				pausedisp(1);
			} else {
				pausedisp(0);
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result;

	grcls(-1);
	spcls(0);
	bgcls();
	bghome(0, 0);

	grprintf( 2, 0, 0xf0, "1");
	grprintf( 3, 0, 0xf2, "UP");
	grprintf( 1, 1, 0xf0, "%6d", game.score);

	grprintf( 8, 0, 0xf2, "HI");
	grprintf(10, 0, 0xf1, "-");
	grprintf(11, 0, 0xf2, "SCORE");
	grprintf( 9, 1, 0xf0, "%6d", hiscore);

	grprintf( 5, 3, 0xf0, "SIMPLE");
	bgdisp(3, 4, &chr_title);

	bgdisp(3, 8, &chr_pattern_no);

	for(;;) {
		schedule();

		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}
		if((joy & TRG_LF) && (pattern_sel > 0)) {
			pattern_sel--;
			sound(SND_FIRE);
		}
		if((joy & TRG_RI) && (pattern_sel < PATTERN_COUNT - 1)) {
			pattern_sel++;
			sound(SND_FIRE);
		}

		grprintf(11, 8, 0xf0, "%2d", pattern_sel + 1);
		grprintf( 1, 8, 0xf1, pattern_sel >                 0 ? "<" : " ");
		grprintf(14, 8, 0xf1, pattern_sel < PATTERN_COUNT - 1 ? ">" : " ");

		if(now % SEC(1) < SEC(0.66)) {
			grprintf( 4,  9, 0xf0, " A ");
			grprintf( 8,  9, 0xf1, "START");
			grprintf( 4, 10, 0xf0, "SEL");
			grprintf( 8, 10, 0xf1, "EXIT ");
		} else {
			grprintf( 4,  9, 0xf0, "   ");
			grprintf( 8,  9, 0xf1, "     ");
			grprintf( 4, 10, 0xf0, "   ");
			grprintf( 8, 10, 0xf1, "     ");
		}
	}
	sound(SND_PLAYER_OUT);

	return result;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int i;

	/* Q[B */
	game_init();

	/*=== p^[Jn ===*/
L_START:
	pattern_init();

	/*=== X^[g ===*/
L_RESTART:
	restart_init();

	/*=== ʏ탋[v ===*/
	for(;;) {
		schedule();

		/* Aj[VJE^XV܂B */
		anim2 = animN++ / SEC(0.2) & 1;

		/*{{BR}h*/
		if(joy & PAD_SELECT) {
			if(joy & TRG_UP) {
				goto L_CLEAR;
			}
			if(joy & TRG_LF) {
				opt_invincible = 0;
			}
			if(joy & TRG_RI) {
				opt_invincible = 1;
			}
		}
		/*}}BR}h*/

		/* ړs܂B */
		/*{{̏ԕK{ł!!*/
		if(!field_action()) {
			goto L_CLEAR; /* p^[NA */
		}
		fire_action();
		player_action();
		ring_action();
		enemy_action();
		enemy_setup();
		/*}}̏ԕK{ł!!*/

		/* 蔻s܂B */
		ht_fire_enemy(); /* U=>G */
		ht_ring_player(); /* O=>vC[ */
		ht_trap_player(); /* =>vC[ */
		ht_enemy_player(); /* G<=>vC[ */
		if(game.player.stat == PLAYER_STAT_DIE) {
			goto L_OUT; /* vC[AEg */
		}

		/* \s܂B */
		game_disp();
	}

	/*=== vC[AEg ===*/
L_OUT:
	sound(SND_PLAYER_OUT);
	game.player.cnt = -SEC(0.25); /* AEgAj[VJnOfBC */
	do {
		game_disp();
		schedule();
		fire_action();
		player_action();
	} while(game.player.stat == PLAYER_STAT_DIE);
	delay(SEC(0.5)); /* AEgAj[VIfBC */

	/* c@炵܂B */
	if(!--game.life) {
		goto L_GAMEOVER; /* Q[I[o[ */
	}

	/* "GET READY"\܂B */
	grcls(3);
	spcls(0);
	bgcls();
	grprintf(3, 5, 0xf1, "GET READY");
	delay(SEC(1));
	grcls(-1);

	goto L_RESTART; /* X^[g */

	/*=== p^[NA ===*/
L_CLEAR:
	sound(SND_CLEAR);
	/* p^[ԍi߂܂B */
	if(game.pattern < PATTERN_MAX) {
		game.pattern++;
	}

	/* ̃p^[ԍ"PATTERN NOxxSTART"\܂B
	 * - "PATTERN NO  START"͊̕DFA"xx"͔̕łB
	 *   "xx"́̕A[łłB(" 1",...," 9","10",...)
	 * - X^[ǵAp^[ԍ\܂B
	 * - Q[JńAp^[ԍ\܂B
	 *   ]āA"PATTERN NO 1START"́A\@܂B
	 */
	grcls(-1);
	spcls(0);
	bgcls();
	bghome(0, 0);
	bgdisp(1, 5, &chr_start);
	grprintf(9, 5, 0x30, "%2d", game.pattern + 1/*1x[X*/);
	delay(SEC(1));

	goto L_START; /* p^[Jn */

	/*=== Q[I[o[ ===*/
L_GAMEOVER:
	/* "GAME OVER"\܂B */
	grcls(3);
	spcls(0);
	bgcls();
	grprintf(3, 5, 0xf1, "GAME OVER");
	for(i = 0; i < SEC(5); i++) {
		schedule();
		if((i >= SEC(1)) && (joy & (TRG_A | TRG_B))) {
			break; /* LZ */
		}
	}
	grcls(-1);

	/* nCXRAXVB */
	if(game.score > hiscore) {
		hiscore = game.score;
	}
}

/****************************************************************************
 *	score_add
 ****************************************************************************/

void
score_add(int pts)
{
	game.score += pts;
	if(game.score > SCORE_MAX) {
		game.score = SCORE_MAX;
	}
}

/****************************************************************************
 *	info_disp
 ****************************************************************************/

void
info_disp()
{
	int i;
	int sprno;
	//
	int score = game.score;
	char buf[] = "1UP     0";

	i = strlen(buf);
	while(score) {
		buf[--i] = score % 10 + '0';
		score /= 10;
	}
	for(i = 0; buf[i]; i++) {
		grfont(15, i, buf[i], isdigit(buf[i]) ? 0xf0 : 0xf2);
	}

	sprno = SPR_LIFE_0 + (game.life - 1);
	spdisp(obj++, DISP_X - CELL_SIZE - 1, DISP_Y - CELL_SIZE, sprno);
}

/****************************************************************************
 *	get_stage
 ****************************************************************************/

void
game_disp()
{
	/*{{̏ԕK{ł!!*/
	obj = 0;
	field_scroll(0);
	field_disp();
	ring_disp();
	enemy_disp();
	fire_disp();
	player_disp();
	info_disp();
	spcls(obj);
	/*}}̏ԕK{ł!!*/
}

/****************************************************************************
 *	get_stage
 ****************************************************************************/

int
get_stage()
{
	/* 0,1,2,3,4,5,6,7,
	 * 0,1,2,3,4,5,6,7,...
	 */
	int i = game.pattern;
	while(i >= STAGE_COUNT) {
		i -= STAGE_COUNT;
	}
	return i;
}

/****************************************************************************
 *	get_pattern
 ****************************************************************************/

int
get_pattern()
{
	/*  0, 1, 2, 3, 4, 5, 6, 7,
	 *  8, 9,10,11,12,13,14,15,
	 * 16,17,18,19,20,21,22,23,
	 * 16,17,18,19,20,21,22,23,...
	 */
	int i = game.pattern;
	while(i >= PATTERN_COUNT) {
		i -= STAGE_COUNT;
	}
	return i;
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	memset(&game, 0, sizeof(GAME));

	game.life = 3;
	game.pattern = pattern_sel;
}

/****************************************************************************
 *	pattern_init
 ****************************************************************************/

void
pattern_init()
{
	int i_stage = get_stage();
	int i_pattern = get_pattern();
	//
	const char* stage;
	const char* pattern;
	int col;
	int row;
	CELL* cell;
	int enemy_init_count;
	int extra_init_count;
	int s;
	int p;
	int i;
	int j;
	int road;

	/* Xe[Wf[^擾܂B */
	stage = stage_table[i_stage];
	if(strlen(stage) != (FIELD_COLS - 2) * (FIELD_ROWS - 2)) {
		DIE();
	}

	/* p^[f[^擾܂B */
	pattern = pattern_table[i_pattern];
	if(strlen(pattern) != (FIELD_COLS - 2) * (FIELD_ROWS - 2)) {
		DIE();
	}

	/* vC[oʒu𖳌ȒlƂĂ܂B */
	game.player_init_col = -1;
	game.player_init_row = -1;

	/* Goʒui[񐔂NAĂ܂B */
	enemy_init_count = 0; /* Goʒui[ */

	/* xoʒu𖳌ȒlƂĂ܂B */
	game.stop_init_col = -1;
	game.stop_init_row = -1;

	/* GNXgoʒu␔NAĂ܂B */
	extra_init_count = 0; /* GNXgoʒu␔ */

	memset(game.field, 0, sizeof game.field);
	for(row = 1; row <= FIELD_ROWS - 2; row++) {
		for(col = 1; col <= FIELD_COLS - 2; col++) {
			cell = &game.field[row][col];

			s = *stage;
			p = *pattern;

			/* ㉺EɌܐL邩ǂׂĂ܂B */
			road = 0;
			if((col >              1) && strchr("#@", *(stage -                1))) {
				road |= CELL_ROAD_LF;
			}
			if((col < FIELD_COLS - 2) && strchr("#@", *(stage +                1))) {
				road |= CELL_ROAD_RI;
			}
			if((row >              1) && strchr("#@", *(stage - (FIELD_COLS - 2)))) {
				road |= CELL_ROAD_UP;
			}
			if((row < FIELD_ROWS - 2) && strchr("#@", *(stage + (FIELD_COLS - 2)))) {
				road |= CELL_ROAD_DN;
			}

			/* ܐ̗Li[܂B */
			switch(s) {
			case '#':
			case '@':
				cell->road = road;
				break;
			}

			/* ̗Li[܂B */
			switch(p) {
			case '.':
			case 'o':
				cell->stat = CELL_STAT_NOTE;
				break;
			}

			switch(s | p << 8) {
			case ' ' | ' ' << 8:
				/* GNXgoʒuƂāACELL_STAT_EXTRAݒ肵Ă܂B */
				if(road) { /* ܐׂ̗Ȃ... */
					cell->stat = CELL_STAT_EXTRA;
					extra_init_count++; /* GNXgoʒu␔ */
				}
				break;
			case ' ' | '.' << 8:
			case '#' | '#' << 8:
			case '#' | 'o' << 8:
				/** no job **/
				break;
			case '@' | '#' << 8:
			case '@' | 'o' << 8:
				/* vC[oʒui[܂B */
				if((game.player_init_col != -1) ||
				   (game.player_init_row != -1)) {
					DIE(); /* vC[oʒu? */
				}
				game.player_init_col = col;
				game.player_init_row = row;
				break;
			case 'x' | ' ' << 8:
				/* Goʒui[܂B */
				if(enemy_init_count >= ENEMY_INIT_MAX) {
					DIE(); /* Goʒu? */
				}
				game.enemy_init_col[enemy_init_count] = col;
				game.enemy_init_row[enemy_init_count] = row;
				enemy_init_count++; /* Goʒui[ */
				break;
			case 's' | ' ' << 8:
				/* xoʒui[܂B */
				if((game.stop_init_col != -1) ||
				   (game.stop_init_row != -1)) {
					DIE(); /* xoʒu? */
				}
				game.stop_init_col = col;
				game.stop_init_row = row;
				break;
			default:
				DIE(); /* Xe[Wf[^A܂́Ap^[f[^s? */
			}

			stage++;
			pattern++;
		}
	}

	/* vC[oʒuݒ肳ꂽƂmF܂B */
	if((game.player_init_col == -1) ||
	   (game.player_init_row == -1)) {
		DIE(); /* vC[oʒu? */
	}
	game.player.col = game.player_init_col;
	game.player.row = game.player_init_row;

	/* Goʒuݒ肳ꂽƂmF܂B */
	if(enemy_init_count != ENEMY_INIT_MAX) {
		DIE(); /* GoʒuȂA܂́A? */
	}

	/* xoʒuݒ肳ꂽƂmF܂B */
	if((game.stop_init_col == -1) ||
	   (game.stop_init_row == -1)) {
		DIE(); /* xoʒu? */
	}

	/* GNXgoʒuIAi[܂B */
	if(!extra_init_count) {
		DIE(); /* GNXgo\Ȉʒu? */
	}
	i = 0;
	j = rnd(extra_init_count); /* 0`(GNXgoʒu␔-1) */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(cell->stat == CELL_STAT_EXTRA) {
				cell->stat = 0; /* CELL_STAT_EXTRANA */
				if(i++ == j) {
					/* GNXgoʒui[܂B */
					game.extra_init_col = col;
					game.extra_init_row = row;
				}
			}
		}
	}
	if(i != extra_init_count) {
		DIE(); /* L蓾Ȃ */
	}

	/* ̉Ԃi[܂B */
	game.weak_time = weak_time_table[i_pattern];

	/* ݂̃p^[ɂAxƃGNXg̏o񐔂ݒ肵܂B */
	game.stop_count = 2;	/* x̓p^[艄ד܂ */
	game.extra_count = 1;	/* GNXg̓p^[艄׈܂ */
}

/****************************************************************************
 *	restart_init
 ****************************************************************************/

void
restart_init()
{
	PLAYER* player = &game.player;
	int i_pattern = get_pattern();
	//
	int col;
	int row;
	CELL* cell;
	int i;

	/* X^[g_̌oߎԂZbg܂B */
	game.elapse = 0;

	/* xo񐔂cĂAڂ̋xo܂ł̌oߎԂi[܂B */
	if(game.stop_count) {
		game.stop_setup_time = STOP_SETUP_TIME_1;
	}

	/* GNXgo񐔂cĂAGNXgo܂ł̌oߎԂi[܂B */
	if(game.extra_count) {
		game.extra_setup_time = rnd_range(EXTRA_SETUP_TIME_MIN, EXTRA_SETUP_TIME_MAX + 1);
	}

	/* vC[܂B */
	memset(player, 0, sizeof(PLAYER));
	player_set_stat(PLAYER_STAT_MOVE);
	player->col = game.player_init_col;
	player->row = game.player_init_row;
	player->dir = DIR_RI;

	/* U܂B */
	memset(game.fire, 0, sizeof game.fire);

	/* G܂B */
	memset(game.enemy, 0, sizeof game.enemy);
	for(i = 0; i < ENEMY_MAX; i++) {
		game.enemy[i].type = enemy_table[i_pattern][i];
	}

	/* ̓GoʒuCfNXZbg܂B */
	game.i_enemy_init = 0;

	/* O܂B */
	memset(game.ring, 0, sizeof game.ring);

	/* 㩁AxAGNXgAŃGtFNgcĂANA܂B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			switch(cell->stat) {
			case CELL_STAT_TRAP:
			case CELL_STAT_STOP:
			case CELL_STAT_EXTRA:
			case CELL_STAT_ERASE:
				cell->stat = 0;
				break;
			}
		}
	}

	/* XN[W܂B */
	field_scroll(1);

	/* ʂNA܂B */
	grcls(-1);
	spcls(0);
	bgcls();
}

/****************************************************************************
 *	get_xy
 ****************************************************************************/

void
get_xy(int col, int row, int dir, fixed pos, int* px, int* py)
{
	int x = col * CELL_SIZE;
	int y = row * CELL_SIZE;

	switch(dir) {
	case DIR_LF: x += fist(pos); break;
	case DIR_RI: x -= fist(pos); break;
	case DIR_UP: y += fist(pos); break;
	case DIR_DN: y -= fist(pos); break;
	default: DIE();
	}

	*px = x;
	*py = y;
}

/****************************************************************************
 *	field_scroll
 ****************************************************************************/

void
field_scroll(int init)
{
	PLAYER* player = &game.player;
	//
	int x;
	int y;

	get_xy(player->col, player->row, player->dir, player->pos, &x, &y);

	/* vC[̈ړx1.xłĂAXN[Pʂ1.0Ƃ܂B
	 * ܂AvC[XN[xĕtė銴łB
	 * ȂƁAXN[K^K^Ă܂܂B
	 */

	x -= (DISP_X - CELL_SIZE) / 2;
	if(x < SCROLL_X_MIN) {
		x = SCROLL_X_MIN;
	} else if(x > SCROLL_X_MAX) {
		x = SCROLL_X_MAX;
	}
	if(init) {
		game.scroll_x = x;
	} else {
		if(game.scroll_x > x) {
			game.scroll_x--;
		} else if(game.scroll_x < x) {
			game.scroll_x++;
		}
	}

	y -= (DISP_Y - CELL_SIZE) / 2;
	if(y < SCROLL_Y_MIN) {
		y = SCROLL_Y_MIN;
	} else if(y > SCROLL_Y_MAX) {
		y = SCROLL_Y_MAX;
	}
	if(init) {
		game.scroll_y = y;
	} else {
		if(game.scroll_y > y) {
			game.scroll_y--;
		} else if(game.scroll_y < y) {
			game.scroll_y++;
		}
	}

	bghome(game.scroll_x, game.scroll_y);
}

/****************************************************************************
 *	field_action
 ****************************************************************************/

int
field_action()
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell;
	int i;

	/* x̏oARłs܂B */
	cell = &game.field[game.stop_init_row][game.stop_init_col];
	if(!cell->stat) { /* o */
		if(game.stop_count) { /* o񐔂cĂ */
			if(game.stop_setup_time <= 0) {
				DIE(); /* L蓾Ȃ */
			}
			if(!--game.stop_setup_time) { /* oԂɓB */
				cell->stat = CELL_STAT_STOP;
				sound(SND_ITEM);
				game.stop_clear_time = STOP_CLEAR_TIME;
				if(--game.stop_count) {
					game.stop_setup_time = STOP_SETUP_TIME_2;
				}
			}
		}
	} else { /* o */
		if(game.stop_clear_time <= 0) {
			DIE(); /* L蓾Ȃ */
		}
		if(!--game.stop_clear_time) { /* RŎԂɓB */
			cell->stat = 0;
		}
	}

	/* GNXg̏oARłs܂B
	 * - őc@ɒBĂA܂B
	 *   vC[AEgAc@ăX^[gꍇ̂߂ɁAo񐔂cĂ܂B
	 */
	if(game.life < LIFE_MAX) {
		cell = &game.field[game.extra_init_row][game.extra_init_col];
		if(!cell->stat) { /* o */
			if(game.extra_count) { /* o񐔂cĂ */
				if(game.extra_setup_time <= 0) {
					DIE(); /* L蓾Ȃ */
				}
				if(!--game.extra_setup_time) { /* oԂɓB */
					cell->stat = CELL_STAT_EXTRA;
					sound(SND_ITEM);
					game.extra_clear_time = EXTRA_CLEAR_TIME;
					if(--game.extra_count) {
						DIE(); /* L蓾Ȃ */
					}
				}
			}
		} else { /* o */
			if(game.extra_clear_time <= 0) {
				DIE(); /* L蓾Ȃ */
			}
			if(!--game.extra_clear_time) { /* RŎԂɓB */
				cell->stat = 0;
			}
		}
	}

	/* ȉ̏s܂B
	 * - cĂ邩ׂ܂B
	 * - ŃGtFNgis܂B
	 */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			switch(cell->stat) {
			case CELL_STAT_NOTE:
				active = 1; /* p^[p */
				break;
			case CELL_STAT_ERASE:
				if(cell->cnt < ARRAY_SIZE(ptn_erase) - 1) {
					cell->cnt++;
				} else {
					memset(cell, 0, sizeof(CELL));
				}
				break;
			}
		}
	}

	/* cĂȂ΁AUcĂ邩ׂ܂B */
	if(!active) {
		for(i = 0; i < FIRE_MAX; i++) {
			if(game.fire[i].active) {
				active = 1; /* p^[p */
				break;
			}
		}
	}

	/* UcĂ΁A1(p^[p)Ԃ܂B
	 * Ȃ΁A0(p^[NA)Ԃ܂B
	 */
	return active;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int col;
	int row;
	CELL* cell;
	int sprno;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];

			switch(cell->stat) {
			case 0:
			case CELL_STAT_NOTE:
			case CELL_STAT_TRAP:
				sprno = ptn_road[cell->stat][cell->road];
				break;
			case CELL_STAT_STOP:
				sprno = ptn_stop[0]; /* z݃p^[player_disp()ɂĕ\ */
				break;
			case CELL_STAT_EXTRA:
				sprno = ptn_extra[0]; /* z݃p^[player_disp()ɂĕ\ */
				break;
			case CELL_STAT_ERASE:
				sprno = ptn_erase[cell->cnt];
				break;
			default:
				DIE();
			}

			bgput(col, row, sprno);
		}
	}
}

/****************************************************************************
 *	player_set_stat
 ****************************************************************************/

void
player_set_stat(int stat)
{
	game.player.stat = stat;
	game.player.cnt = 0;
}

/****************************************************************************
 *	player_action
 ****************************************************************************/

/* U */
static void
player_action_sub1()
{
	PLAYER* player = &game.player;
	//
	int col;
	int row;
	CELL* cell;

	/* ʏԂłȂ(ԂȂ)A܂B */
	if(player->stat != PLAYER_STAT_MOVE) {
		return;
	}

	col = player->col;
	row = player->row;
	switch(player->dir) {
	case DIR_LF: if(--col <=              0) return; break;
	case DIR_RI: if(++col >= FIELD_COLS - 1) return; break;
	case DIR_UP: if(--row <=              0) return; break;
	case DIR_DN: if(++row >= FIELD_ROWS - 1) return; break;
	default: DIE();
	}

	cell = &game.field[row][col];
	switch(cell->stat) {
	case CELL_STAT_NOTE:
		cell->stat = 0;
		fire_gen(col, row, player->dir);
		sound(SND_FIRE);
		score_add(20); /* XRA */
		break;
	}
}

/* xAGNXgzݔ */
static void
player_action_sub2()
{
	PLAYER* player = &game.player;
	//
	int col;
	int row;
	CELL* cell;
	int i;
	ENEMY* enemy;

	/* ʏԂłȂ(ԂȂ)A܂B */
	if(player->stat != PLAYER_STAT_MOVE) {
		return;
	}

	col = player->col;
	row = player->row;
	switch(player->dir) {
	case DIR_LF: if(--col <=              0) return; break;
	case DIR_RI: if(++col >= FIELD_COLS - 1) return; break;
	case DIR_UP: if(--row <=              0) return; break;
	case DIR_DN: if(++row >= FIELD_ROWS - 1) return; break;
	default: DIE();
	}

	cell = &game.field[row][col];
	switch(cell->stat) {
	case CELL_STAT_STOP:
		cell->stat = 0;
		player_set_stat(PLAYER_STAT_STOP);
		sound(SND_ITEM);
		score_add(300); /* xXRA */
		/*{{G̉*/
		for(i = 0; i < ENEMY_MAX; i++) {
			enemy = &game.enemy[i];
			switch(enemy->stat) {
			case ENEMY_STAT_SETUP:
			case ENEMY_STAT_MOVE:
			case ENEMY_STAT_CHANGE:
				enemy->weak = game.weak_time;
				break;
			}
		}
		/*}}G̉*/
		break;

	case CELL_STAT_EXTRA:
		cell->stat = 0;
		player_set_stat(PLAYER_STAT_EXTRA);
		sound(SND_ITEM);
		/*{{c@Abv*/
		if(++game.life > LIFE_MAX) {
			DIE(); /* L蓾Ȃ */
		}
		/*}}c@Abv*/
		break;
	}
}

void
player_action()
{
	PLAYER* player = &game.player;
	//
	fixed spd = LAPAPA_SPD;
	CELL* cell;
	int active;

	switch(player->stat) {
	case PLAYER_STAT_MOVE:
	case PLAYER_STAT_HIDE:
		/* B */
		switch(player->stat) {
		case PLAYER_STAT_MOVE:
			if(joy & (TRG_A | TRG_B)) {
				player_set_stat(PLAYER_STAT_HIDE); /* Jn */
				sound(SND_PLAYER_HIDE);
			}
			break;
		case PLAYER_STAT_HIDE:
			if(player->cnt < ARRAY_SIZE(ptn_lapapa_hide[0/*dir*/]) - 1) {
				player->cnt++; /* is */
			} else {
				player_set_stat(PLAYER_STAT_MOVE); /* I */
			}
			break;
		default:
			DIE();
		}
		/* ̈ړ\cĂ... */
		while(spd) {
			/* ړԂȂ... */
			if(player->pos) {
				/* ]? */
				if((player->dir == DIR_RI) && (joy & PAD_LF)) {
					player->dir = DIR_LF;
					player->col--;
					player->pos = fsub(fild(CELL_SIZE), player->pos);
				} else if((player->dir == DIR_LF) && (joy & PAD_RI)) {
					player->dir = DIR_RI;
					player->col++;
					player->pos = fsub(fild(CELL_SIZE), player->pos);
				} else if((player->dir == DIR_DN) && (joy & PAD_UP)) {
					player->dir = DIR_UP;
					player->row--;
					player->pos = fsub(fild(CELL_SIZE), player->pos);
				} else if((player->dir == DIR_UP) && (joy & PAD_DN)) {
					player->dir = DIR_DN;
					player->row++;
					player->pos = fsub(fild(CELL_SIZE), player->pos);
				}
				/* ړpB */
				if(fcom(player->pos, >, spd)) {
					player->pos = fsub(player->pos, spd);
					spd = 0;
				} else {
					spd = fsub(player->pos, player->pos);
					player->pos = 0;
				}
				if(!player->pos) {
					/* ÚApbh͖łAiŝЂƂ̃Zɑ΂čs܂B
					 * xAGNXgź݂A~Ԃ̃pbh͂΍s܂B
					 */
					player_action_sub1(); /* Ûݍs */
				}
			/* ~ԂȂ... */
			} else {
				/* ړJn? */
				active = 0;
				if(joy & PAD_LF) {
					player->dir = DIR_LF;
					player_action_sub1(); /* U */
					player_action_sub2(); /* xAGNXgz */
					if(player->col > 0) {
						cell = &game.field[player->row][player->col];
						if(cell->road & CELL_ROAD_LF) {
							player->col--;
							player->pos = fild(CELL_SIZE);
							active = 1;
						}
					}
				} else if(joy & PAD_RI) {
					player->dir = DIR_RI;
					player_action_sub1(); /* U */
					player_action_sub2(); /* xAGNXgz */
					if(player->col < FIELD_COLS - 1) {
						cell = &game.field[player->row][player->col];
						if(cell->road & CELL_ROAD_RI) {
							player->col++;
							player->pos = fild(CELL_SIZE);
							active = 1;
						}
					}
				} else if(joy & PAD_UP) {
					player->dir = DIR_UP;
					player_action_sub1(); /* U */
					player_action_sub2(); /* xAGNXgz */
					if(player->row > 0) {
						cell = &game.field[player->row][player->col];
						if(cell->road & CELL_ROAD_UP) {
							player->row--;
							player->pos = fild(CELL_SIZE);
							active = 1;
						}
					}
				} else if(joy & PAD_DN) {
					player->dir = DIR_DN;
					player_action_sub1(); /* U */
					player_action_sub2(); /* xAGNXgz */
					if(player->row < FIELD_ROWS - 1) {
						cell = &game.field[player->row][player->col];
						if(cell->road & CELL_ROAD_DN) {
							player->row++;
							player->pos = fild(CELL_SIZE);
							active = 1;
						}
					}
				}
				if(!active) {
					spd = 0;
				}
			}
		}
		break;

	case PLAYER_STAT_STOP:
	case PLAYER_STAT_EXTRA:
		if(player->cnt < SEC(0.2/**/)) {
			player->cnt++;
		} else {
			player_set_stat(PLAYER_STAT_MOVE);
		}
		break;

	case PLAYER_STAT_DIE:
		if(player->cnt < ARRAY_SIZE(ptn_lapapa_die) - 1) {
			player->cnt++;
		} else {
			player_set_stat(0);
		}
		break;

	default:
		DIE();
	}
}

/****************************************************************************
 *	player_disp
 ****************************************************************************/

void
player_disp()
{
	PLAYER* player = &game.player;
	//
	int x;
	int y;
	int sprno;

	switch(player->stat) {
	case PLAYER_STAT_MOVE:
		sprno = ptn_lapapa[player->dir][anim2];
		break;

	case PLAYER_STAT_HIDE:
		sprno = ptn_lapapa_hide[player->dir][player->cnt];
		break;

	case PLAYER_STAT_STOP:
		get_xy(player->col, player->row, player->dir, player->pos, &x, &y);
		switch(player->dir) {
		case DIR_LF: sprno = SPR_STOP_L; x -= CELL_SIZE; break;
		case DIR_RI: sprno = SPR_STOP_R; x += CELL_SIZE; break;
		case DIR_UP: sprno = SPR_STOP_U; y -= CELL_SIZE; break;
		case DIR_DN: sprno = SPR_STOP_D; y += CELL_SIZE; break;
		default: DIE();
		}
		spdisp(obj++, x - game.scroll_x, y - game.scroll_y, sprno);
		sprno = ptn_lapapa[player->dir][anim2];
		break;

	case PLAYER_STAT_EXTRA:
		get_xy(player->col, player->row, player->dir, player->pos, &x, &y);
		switch(player->dir) {
		case DIR_LF: sprno = SPR_EXTRA_L; x -= CELL_SIZE; break;
		case DIR_RI: sprno = SPR_EXTRA_R; x += CELL_SIZE; break;
		case DIR_UP: sprno = SPR_EXTRA_U; y -= CELL_SIZE; break;
		case DIR_DN: sprno = SPR_EXTRA_D; y += CELL_SIZE; break;
		default: DIE();
		}
		spdisp(obj++, x - game.scroll_x, y - game.scroll_y, sprno);
		sprno = ptn_lapapa[player->dir][anim2];
		break;

	case PLAYER_STAT_DIE:
		if(player->cnt < 0) {
			sprno = ptn_lapapa[player->dir][0]; /* AEgAj[VJnOfBC */
		} else {
			sprno = ptn_lapapa_die[player->cnt];
		}
		break;

	default:
		DIE();
	}

	get_xy(player->col, player->row, player->dir, player->pos, &x, &y);

	spdisp(obj++, x - game.scroll_x, y - game.scroll_y, sprno);
}

/****************************************************************************
 *	fire_gen
 ****************************************************************************/

void
fire_gen(int col, int row, int dir)
{
	int i;
	FIRE* fire;

	/* ̃ZJn܂B
	 * - Q[[vAfire_action()Aplayer_action()̏ŌĂяo邱ƂOłB
	 * - fire->pos̏lAZA납n܂邱ƂOłB(̊֐̌㔼Q)
	 * - ȏ̏ɂāAÚAvC[̑OZ悩Jn܂B
	 */
	switch(dir) {
	case DIR_LF: if(--col <              0) return; break;
	case DIR_RI: if(++col > FIELD_COLS - 1) return; break;
	case DIR_UP: if(--row <              0) return; break;
	case DIR_DN: if(++row > FIELD_ROWS - 1) return; break;
	default: DIE();
	}

	for(i = 0; i < FIRE_MAX; i++) {
		fire = &game.fire[i];
		if(!fire->active) { /*  */
			memset(fire, 0, sizeof(FIRE));
			fire->active = 1;
			fire->col = col;
			fire->row = row;
			fire->dir = dir;
			fire->pos = fild(CELL_SIZE / 2); /* tB[h̉ƏdȂȂ悤 */
			return; /* ܂ */
		}
	}
}

/****************************************************************************
 *	fire_action
 ****************************************************************************/

void
fire_action()
{
	int i;
	FIRE* fire;
	CELL* cell;

	for(i = 0; i < FIRE_MAX; i++) {
		fire = &game.fire[i];
		if(!fire->active) { /*  */
			continue;
		}

		fire->pos = fsub(fire->pos, FIRE_SPD);
		while(ficom(fire->pos, <, 0)) {
			switch(fire->dir) {
			case DIR_LF: if(--fire->col <              0) { memset(fire, 0, sizeof(FIRE)); goto L_NEXT; } break;
			case DIR_RI: if(++fire->col > FIELD_COLS - 1) { memset(fire, 0, sizeof(FIRE)); goto L_NEXT; } break;
			case DIR_UP: if(--fire->row <              0) { memset(fire, 0, sizeof(FIRE)); goto L_NEXT; } break;
			case DIR_DN: if(++fire->row > FIELD_ROWS - 1) { memset(fire, 0, sizeof(FIRE)); goto L_NEXT; } break;
			default: DIE();
			}
			fire->pos = fiadd(fire->pos, CELL_SIZE);

			cell = &game.field[fire->row][fire->col];
			switch(cell->stat) {
			case CELL_STAT_TRAP:
				cell->stat = 0; /* ŃGtFNg */
				sound(SND_ITEM_OUT);
				break;
			case CELL_STAT_STOP:
			case CELL_STAT_EXTRA:
				cell->stat = CELL_STAT_ERASE; /* ŃGtFNgL */
				cell->cnt = 0;
				sound(SND_ITEM_OUT);
				break;
			}
		}
L_NEXT:
	}
}

/****************************************************************************
 *	fire_disp
 ****************************************************************************/

void
fire_disp()
{
	int i;
	FIRE* fire;
	int x;
	int y;

	for(i = 0; i < FIRE_MAX; i++) {
		fire = &game.fire[i];
		if(!fire->active) { /*  */
			continue;
		}

		get_xy(fire->col, fire->row, fire->dir, fire->pos, &x, &y);
		spdisp(obj++, x - game.scroll_x, y - game.scroll_y, SPR_FIRE);
	}
}

/****************************************************************************
 *	enemy_set_stat
 ****************************************************************************/

void
enemy_set_stat(ENEMY* enemy, int stat)
{
	enemy->stat = stat;
	enemy->cnt = 0;
	enemy->weak = 0; /* Kv!! Ƃ΁AʏԂ̎̉AEgւ̏ԕωȂǂ̂ */
	enemy->attack = 0; /* AEgďoɂāAUJE^Zbg */
	//enemy->change = ̂܂܁BAEgďoĂAJEgp */
}

/****************************************************************************
 *	enemy_setup
 ****************************************************************************/

void
enemy_setup()
{
	int enemy_count = game.elapse++ < ENEMY_EXTRA_TIME ? ENEMY_MAX - 1 : ENEMY_MAX;
	//
	int i;
	ENEMY* enemy;

	/* ɓCȏ̏os܂B */
	for(i = 0; i < enemy_count; i++) {
		enemy = &game.enemy[i];
		if(enemy->stat == ENEMY_STAT_SETUP) {
			return;
		}
	}

	/* o҂̓GT܂B */
	for(i = 0; i < enemy_count; i++) {
		enemy = &game.enemy[i];
		if(!enemy->type/**/ || enemy->stat/*ғ*/) {
			continue;
		}

		//memset(enemy, 0, sizoef(ENEMY));  type,elapse͌p̂ŁANAĂ̓_!!
		enemy_set_stat(enemy, ENEMY_STAT_SETUP);
		enemy->col = game.enemy_init_col[game.i_enemy_init];
		enemy->row = game.enemy_init_row[game.i_enemy_init];
		enemy->dir = 0; /* oɐݒ肵܂ */
		enemy->pos = 0;

		/* ̓GoʒuCfNXi߂܂B */
		if(game.i_enemy_init < ENEMY_INIT_MAX - 1) {
			game.i_enemy_init++;
		} else {
			game.i_enemy_init = 0;
		}

		return; /* ܂ */
	}
}

/****************************************************************************
 *	enemy_action
 ****************************************************************************/

typedef struct _DIR_DIST {
	int dir;	/*  */
	int dist;	/* vC[̋^2 */
} DIR_DIST;

static int dir_dist_compare(const void* _a, const void* _b) {
	const DIR_DIST* a = _a;
	const DIR_DIST* b = _b;
	return a->dist < b->dist ? -1 :
	       a->dist > b->dist ?  1 : 0;
}

static int
chase_dir(ENEMY* enemy)
{
	PLAYER* player = &game.player;
	//
	int col;
	int row;
	CELL* cell;
	int i;
	int n;
	int r;
	int col_diff;
	int row_diff;
	DIR_DIST dir_dist[4];

	col = enemy->col;
	row = enemy->row;
	cell = &game.field[row][col];

	/* ړ\ȕ΁Aō̗p܂B
	 * ݂̈ړ̋tłĂA̗p܂B
	 */
	switch(cell->road) {
	case CELL_ROAD_LF: return DIR_LF;
	case CELL_ROAD_RI: return DIR_RI;
	case CELL_ROAD_UP: return DIR_UP;
	case CELL_ROAD_DN: return DIR_DN;
	}

	/* ړ\ȕꂼɂāAvC[̋߂܂B
	 * Ä݂ړ̋t́AO܂B
	 */
	n = 0;
	if((cell->road & CELL_ROAD_LF) && (enemy->dir != DIR_RI)) {
		dir_dist[n].dir = DIR_LF;
		col_diff = abs(player->col - (col - 1));
		row_diff = abs(player->row - (row    ));
		dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
		n++;
	}
	if((cell->road & CELL_ROAD_RI) && (enemy->dir != DIR_LF)) {
		dir_dist[n].dir = DIR_RI;
		col_diff = abs(player->col - (col + 1));
		row_diff = abs(player->row - (row    ));
		dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
		n++;
	}
	if((cell->road & CELL_ROAD_UP) && (enemy->dir != DIR_DN)) {
		dir_dist[n].dir = DIR_UP;
		col_diff = abs(player->col - (col    ));
		row_diff = abs(player->row - (row - 1));
		dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
		n++;
	}
	if((cell->road & CELL_ROAD_DN) && (enemy->dir != DIR_UP)) {
		dir_dist[n].dir = DIR_DN;
		col_diff = abs(player->col - (col    ));
		row_diff = abs(player->row - (row + 1));
		dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
		n++;
	}

	/* tAvC[̋̏ɕёւ܂B */
	qsort(dir_dist, n, sizeof(DIR_DIST), dir_dist_compare);

	/* t␔ɂāAقȂdݕtŕI܂B */
	switch(n) {
	case 1:
		/* t₪Ȃ΁A{100%} őI܂B */
		i = 0;
		break;
	case 2:
		/* t₪jȂ΁A{90%,10%} őI܂B */
		r = rnd(100);
		i = r < 90 ? 0 : 1;
		break;
	case 3:
		/* t₪OȂ΁A{85%,10%,5%} őI܂B */
		r = rnd(100);
		i = r < 85 ? 0 :
		    r < 95 ? 1 : 2;
		break;
	default:
		DIE();
	}
	return dir_dist[i].dir;
}

static int
random_dir(ENEMY* enemy)
{
	int col;
	int row;
	CELL* cell;
	int i;
	int n;
	DIR_DIST dir_dist[4];

	col = enemy->col;
	row = enemy->row;
	cell = &game.field[row][col];

	/* ړ\ȕ΁Aō̗p܂B
	 * - ݂̈ړ̋tłĂA̗p܂B
	 */
	switch(cell->road) {
	case CELL_ROAD_LF: return DIR_LF;
	case CELL_ROAD_RI: return DIR_RI;
	case CELL_ROAD_UP: return DIR_UP;
	case CELL_ROAD_DN: return DIR_DN;
	}

	/* ړ\ȕ߂܂B
	 * - ݂̈ړ̋t́AO܂B
	 */
	n = 0;
	if((cell->road & CELL_ROAD_LF) && (enemy->dir != DIR_RI)) {
		dir_dist[n].dir = DIR_LF;
		//col_diff = abs(player->col - (col - 1));
		//row_diff = abs(player->row - (row    ));
		//dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
		n++;
	}
	if((cell->road & CELL_ROAD_RI) && (enemy->dir != DIR_LF)) {
		dir_dist[n].dir = DIR_RI;
		//col_diff = abs(player->col - (col + 1));
		//row_diff = abs(player->row - (row    ));
		//dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
		n++;
	}
	if((cell->road & CELL_ROAD_UP) && (enemy->dir != DIR_DN)) {
		dir_dist[n].dir = DIR_UP;
		//col_diff = abs(player->col - (col    ));
		//row_diff = abs(player->row - (row - 1));
		//dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
		n++;
	}
	if((cell->road & CELL_ROAD_DN) && (enemy->dir != DIR_UP)) {
		dir_dist[n].dir = DIR_DN;
		//col_diff = abs(player->col - (col    ));
		//row_diff = abs(player->row - (row + 1));
		//dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
		n++;
	}
	if(!n) {
		DIE();
	}

	/* ړI܂B
	 * - vC[̋͊֌WA_ɑI܂B
	 */
	i = rnd(n);
	return dir_dist[i].dir;
}

static int
zigzag_dir(ENEMY* enemy)
{
	PLAYER* player = &game.player;
	//
	int col;
	int row;
	int i;
	int n;
	int r;
	int col_diff;
	int row_diff;
	DIR_DIST dir_dist[4];

	col = enemy->col;
	row = enemy->row;

	/* ړ̌ƁAvC[̋߂܂B
	 * - ܐ̗ĹA֌WL܂B
	 *   sAḿAʓȂ΁Aܐ̖ꏊړ\łB
	 * - ݂̈ړƂ̋t́AO܂B
	 *   Ȃ킿AɒpɋȂ܂B
	 */
	n = 0;
	switch(enemy->dir) {
	case DIR_LF:
	case DIR_RI:
		if(row > 0) {
			dir_dist[n].dir = DIR_UP;
			col_diff = abs(player->col - (col    ));
			row_diff = abs(player->row - (row - 1));
			dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
			n++;
		}
		if(row < FIELD_ROWS - 1) {
			dir_dist[n].dir = DIR_DN;
			col_diff = abs(player->col - (col    ));
			row_diff = abs(player->row - (row + 1));
			dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
			n++;
		}
		break;
	case DIR_UP:
	case DIR_DN:
		if(col > 0) {
			dir_dist[n].dir = DIR_LF;
			col_diff = abs(player->col - (col - 1));
			row_diff = abs(player->row - (row    ));
			dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
			n++;
		}
		if(col < FIELD_COLS - 1) {
			dir_dist[n].dir = DIR_RI;
			col_diff = abs(player->col - (col + 1));
			row_diff = abs(player->row - (row    ));
			dir_dist[n].dist = col_diff * col_diff + row_diff * row_diff;
			n++;
		}
		break;
	}
	if(!n) {
		DIE();
	}

	/* ړ̌AvC[̋̏ɕёւ܂B */
	qsort(dir_dist, n, sizeof(DIR_DIST), dir_dist_compare);

	/* ړ̌␔ɂāAقȂdݕtŕI܂B */
	switch(n) {
	case 1:
		/* ړ̌₪Ȃ΁A{100%} őI܂B */
		i = 0;
		break;
	case 2:
		/* ړ̌₪jȂ΁A{90%,10%} őI܂B */
		r = rnd(100);
		i = r < 90 ? 0 : 1;
		break;
	default:
		DIE();
	}
	return dir_dist[i].dir;
}

static int
guitaco_dir(ENEMY* enemy)
{
	return chase_dir(enemy);
}

static int
guitaro_dir(ENEMY* enemy)
{
	return chase_dir(enemy);
}

static int
trien_dir(ENEMY* enemy)
{
	return chase_dir(enemy);
}

static int
madphone_dir(ENEMY* enemy)
{
	return random_dir(enemy);
}

static int
cymbomb_dir(ENEMY* enemy)
{
	return random_dir(enemy);
}

static int
pianha_dir(ENEMY* enemy)
{
	return zigzag_dir(enemy);
}

static void
madphone_attack(ENEMY* enemy)
{
	int col;
	int row;
	int dir;

	col = enemy->col;
	row = enemy->row;
	dir = enemy->dir;

	ring_gen(col, row, dir);
	sound(SND_ATTACK);
}

static void
trien_attack(ENEMY* enemy)
{
	int col;
	int row;
	CELL* cell;

	col = enemy->col;
	row = enemy->row;
	cell = &game.field[row][col];

	if(!cell->stat) {
		cell->stat = CELL_STAT_TRAP;
		sound(SND_ATTACK);
	}
}

static void
cymbomb_attack(ENEMY* enemy)
{
	int col;
	int row;
	CELL* cell;

	col = enemy->col;
	row = enemy->row;
	cell = &game.field[row][col];

	if(!cell->stat) {
		cell->stat = CELL_STAT_NOTE;
		sound(SND_ATTACK);
	}
}

void
enemy_action()
{
	int i;
	ENEMY* enemy;
	fixed spd;

	for(i = 0; i < ENEMY_MAX; i++) {
		enemy = &game.enemy[i];
		if(!enemy->stat) { /* o */
			continue;
		}
		if(enemy->weak) { /* ̉ (M^[()͒~̂) */
			enemy->weak--;
			continue;
		}

		switch(enemy->stat) {
		case ENEMY_STAT_SETUP:
			if(enemy->cnt < ARRAY_SIZE(ptn_setup) - 1) {
				enemy->cnt++;
			} else {
				enemy_set_stat(enemy, ENEMY_STAT_MOVE);
				/*{{ó̕AܐL邩ǂAEAAȀɒׂČ肷dlłB*/
				     if((enemy->col < FIELD_COLS - 1) && (game.field[enemy->row][enemy->col + 1].road)) { enemy->col++; enemy->dir = DIR_RI; }
				else if((enemy->col >              0) && (game.field[enemy->row][enemy->col - 1].road)) { enemy->col--; enemy->dir = DIR_LF; }
				else if((enemy->row >              0) && (game.field[enemy->row - 1][enemy->col].road)) { enemy->row--; enemy->dir = DIR_UP; }
				else if((enemy->row < FIELD_COLS - 1) && (game.field[enemy->row + 1][enemy->col].road)) { enemy->row++; enemy->dir = DIR_DN; }
				else DIE();
				/*}}ó̕AܐL邩ǂAEAAȀɒׂČ肷dlłB*/
				enemy->pos = fild(CELL_SIZE);
			}
			break;

		case ENEMY_STAT_MOVE:
			switch(enemy->type) {
			case ENEMY_TYPE_GUITACO:  spd = GUITACO_SPD;  break;
			case ENEMY_TYPE_GUITARO:  spd = GUITARO_SPD;  break;
			case ENEMY_TYPE_MADPHONE: spd = MADPHONE_SPD; break;
			case ENEMY_TYPE_TRIEN:    spd = TRIEN_SPD;    break;
			case ENEMY_TYPE_CYMBOMB:  spd = CYMBOMB_SPD;  break;
			case ENEMY_TYPE_PIANHA:   spd = PIANHA_SPD;   break;
			default: DIE();
			}
			while(spd) {
				if(enemy->pos) {
					if(fcom(enemy->pos, >, spd)) {
						enemy->pos = fsub(enemy->pos, spd);
						spd = 0;
					} else {
						spd = fsub(enemy->pos, enemy->pos);
						enemy->pos = 0;
					}
				} else {
					/* ZʒuύXOɁAUs܂B */
					if(enemy->attack) {
						if(!--enemy->attack) {
							switch(enemy->type) {
							case ENEMY_TYPE_MADPHONE: madphone_attack(enemy); break;
							case ENEMY_TYPE_TRIEN:       trien_attack(enemy); break;
							case ENEMY_TYPE_CYMBOMB:   cymbomb_attack(enemy); break;
							}
						}
					}
					if(!enemy->attack) {
						/* ̍U܂ł́AړZ肵܂B */
						switch(enemy->type) {
						case ENEMY_TYPE_MADPHONE: enemy->attack = rnd_range(MADPHONE_ATTACK_MIN, MADPHONE_ATTACK_MAX + 1); break;
						case ENEMY_TYPE_TRIEN:    enemy->attack = rnd_range(   TRIEN_ATTACK_MIN,    TRIEN_ATTACK_MAX + 1); break;
						case ENEMY_TYPE_CYMBOMB:  enemy->attack = rnd_range( CYMBOMB_ATTACK_MIN,   CYMBOM_ATTACK_MAX + 1); break;
						}
					}
					/* ړ肵AZʒuύX܂B */
					switch(enemy->type) {
					case ENEMY_TYPE_GUITACO:  enemy->dir = guitaco_dir(enemy);  break;
					case ENEMY_TYPE_GUITARO:  enemy->dir = guitaro_dir(enemy);  break;
					case ENEMY_TYPE_MADPHONE: enemy->dir = madphone_dir(enemy); break;
					case ENEMY_TYPE_TRIEN:    enemy->dir = trien_dir(enemy);    break;
					case ENEMY_TYPE_CYMBOMB:  enemy->dir = cymbomb_dir(enemy);  break;
					case ENEMY_TYPE_PIANHA:   enemy->dir = pianha_dir(enemy);   break;
					default: DIE();
					}
					switch(enemy->dir) {
					case DIR_LF: enemy->col--; break;
					case DIR_RI: enemy->col++; break;
					case DIR_UP: enemy->row--; break;
					case DIR_DN: enemy->row++; break;
					default: DIE();
					}
					if((enemy->col < 0) || (enemy->col > FIELD_COLS - 1) ||
					   (enemy->row < 0) || (enemy->row > FIELD_ROWS - 1)) {
						DIE(); /* *_dir()֐̏s? */
					}
					enemy->pos = fild(CELL_SIZE);
				}
			}
			/*{{M^[()=>()*/
			if(enemy->type == ENEMY_TYPE_GUITACO) {
				if(++enemy->change >= GUITACO_GUITARO_TIME) {
					enemy->type = ENEMY_TYPE_GUITARO;
					enemy_set_stat(enemy, ENEMY_STAT_CHANGE);
				}
			}
			/*}}M^[()=>()*/
			break;

		case ENEMY_STAT_CHANGE:
			if(enemy->cnt < ARRAY_SIZE(ptn_change[0/*dir*/]) - 1) {
				enemy->cnt++;
			} else {
				enemy_set_stat(enemy, ENEMY_STAT_MOVE);
			}
			break;

		case ENEMY_STAT_DIE:
			if(enemy->cnt < ARRAY_SIZE(ptn_enemy_die[0/*type*/]) - 1) {
				enemy->cnt++;
			} else {
				enemy_set_stat(enemy, ENEMY_STAT_PTS);
				/*{{UɂGXRA*/
				switch(enemy->type) {
				case ENEMY_TYPE_GUITACO:  enemy->pts = 200; break;
				case ENEMY_TYPE_GUITARO:  enemy->pts = 600; break;
				case ENEMY_TYPE_MADPHONE: enemy->pts = 300; break;
				case ENEMY_TYPE_TRIEN:    enemy->pts = 600; break;
				case ENEMY_TYPE_CYMBOMB:  enemy->pts = 400; break;
				case ENEMY_TYPE_PIANHA:   enemy->pts = 800; break;
				default: DIE();
				}
				score_add(enemy->pts);
				/*}}UɂGXRA*/
			}
			break;

		case ENEMY_STAT_PTS:
			if(enemy->cnt < SEC(0.5/**/)) {
				enemy->cnt++;
			} else {
				enemy_set_stat(enemy, 0);
			}
			break;
		}
	}
}

/****************************************************************************
 *	enemy_disp
 ****************************************************************************/

void
enemy_disp()
{
	int i;
	ENEMY* enemy;
	int x;
	int y;
	int sprno;

	for(i = 0; i < ENEMY_MAX; i++) {
		enemy = &game.enemy[i];
		if(!enemy->stat) { /* o */
			continue;
		}

		switch(enemy->stat) {
		case ENEMY_STAT_SETUP:
			sprno = ptn_setup[enemy->cnt];
			break;

		case ENEMY_STAT_MOVE:
			sprno = ptn_enemy[enemy->type][enemy->dir][anim2];
			if(enemy->weak &&
			  (enemy->type != ENEMY_TYPE_GUITARO)) {
				if(enemy->weak < SEC(5/**/)) {
					if(anim2) {
						sprno = SPR_WEAK_2;
					}
				} else {
					sprno = ptn_weak[anim2];
				}
			}
			break;

		case ENEMY_STAT_CHANGE:
			if(!enemy->weak) {
				sprno = ptn_change[enemy->dir][enemy->cnt];
			} else {
				sprno = ptn_enemy[enemy->type][enemy->dir][anim2];
			}
			break;

		case ENEMY_STAT_DIE:
			sprno = ptn_enemy_die[enemy->type][enemy->cnt];
			break;

		case ENEMY_STAT_PTS:
			switch(enemy->pts) {
			case 50:   sprno = SPR_PTS_50;   break;
			case 100:  sprno = SPR_PTS_100;  break;
			case 200:  sprno = SPR_PTS_200;  break;
			case 300:  sprno = SPR_PTS_300;  break;
			case 400:  sprno = SPR_PTS_400;  break;
			case 600:  sprno = SPR_PTS_600;  break;
			case 800:  sprno = SPR_PTS_800;  break;
			case 1600: sprno = SPR_PTS_1600; break;
			case 3200: sprno = SPR_PTS_3200; break;
			default: DIE();
			}
			break;

		default:
			DIE();
		}

		get_xy(enemy->col, enemy->row, enemy->dir, enemy->pos, &x, &y);
		spdisp(obj++, x - game.scroll_x, y - game.scroll_y, sprno);
	}
}

/****************************************************************************
 *	ring_gen
 ****************************************************************************/

void
ring_gen(int col, int row, int dir)
{
	int i;
	RING* ring;

	for(i = 0; i < RING_MAX; i++) {
		ring = &game.ring[i];
		if(!ring->active) { /*  */
			memset(ring, 0, sizeof(RING));
			ring->active = 1;
			ring->col = col;
			ring->row = row;
			ring->dir = dir;
			return; /* ܂ */
		}
	}
}

/****************************************************************************
 *	ring_action
 ****************************************************************************/

void
ring_action()
{
	int i;
	RING* ring;

	for(i = 0; i < RING_MAX; i++) {
		ring = &game.ring[i];
		if(!ring->active) { /*  */
			continue;
		}

		ring->pos = fsub(ring->pos, RING_SPD);
		while(ficom(ring->pos, <, 0)) {
			switch(ring->dir) {
			case DIR_LF: if(--ring->col <              0) { memset(ring, 0, sizeof(RING)); goto L_NEXT; } break;
			case DIR_RI: if(++ring->col > FIELD_COLS - 1) { memset(ring, 0, sizeof(RING)); goto L_NEXT; } break;
			case DIR_UP: if(--ring->row <              0) { memset(ring, 0, sizeof(RING)); goto L_NEXT; } break;
			case DIR_DN: if(++ring->row > FIELD_ROWS - 1) { memset(ring, 0, sizeof(RING)); goto L_NEXT; } break;
			default: DIE();
			}
			ring->pos = fiadd(ring->pos, CELL_SIZE);
		}
L_NEXT:
	}
}

/****************************************************************************
 *	ring_disp
 ****************************************************************************/

void
ring_disp()
{
	int i;
	RING* ring;
	int x;
	int y;
	int sprno = ptn_ring[animN % ARRAY_SIZE(ptn_ring)];

	for(i = 0; i < RING_MAX; i++) {
		ring = &game.ring[i];
		if(!ring->active) { /*  */
			continue;
		}

		get_xy(ring->col, ring->row, ring->dir, ring->pos, &x, &y);
		spdisp(obj++, x - game.scroll_x, y - game.scroll_y, sprno);
	}
}

/****************************************************************************
 *	ht_fire_enemy
 ****************************************************************************/

#define HT_SIZE CELL_SIZE	/*  */

void
ht_fire_enemy()
{
	int i_fire;
	FIRE* fire;
	int fire_x;
	int fire_y;
	//
	int i_enemy;
	ENEMY* enemy;
	int enemy_x;
	int enemy_y;

	for(i_fire = 0; i_fire < FIRE_MAX; i_fire++) {
		fire = &game.fire[i_fire];
		if(!fire->active) { /*  */
			continue;
		}

		get_xy(fire->col, fire->row, fire->dir, fire->pos, &fire_x, &fire_y);

		for(i_enemy = 0; i_enemy < ENEMY_MAX; i_enemy++) {
			enemy = &game.enemy[i_enemy];
			if(!(enemy->stat & HT)) { /* 蔻薳 */
				continue;
			}

			/* ̉Ȃ΁AU͓܂B(AM^[()͒~݂̂Ȃ̂ŁA) */
			if(enemy->weak &&
			  (enemy->type != ENEMY_TYPE_GUITARO)) {
				continue;
			}

			get_xy(enemy->col, enemy->row, enemy->dir, enemy->pos, &enemy_x, &enemy_y);

			if((abs(fire_x - enemy_x) < HT_SIZE) &&
			   (abs(fire_y - enemy_y) < HT_SIZE)) {
				enemy_set_stat(enemy, ENEMY_STAT_DIE);
				sound(SND_ENEMY_OUT);
				/* p */
			}
		}
	}
}

#undef HT_SIZE

/****************************************************************************
 *	ht_ring_player
 ****************************************************************************/

#define HT_SIZE (CELL_SIZE / 2) /*  */

void
ht_ring_player()
{
	PLAYER* player = &game.player;
	int player_x;
	int player_y;
	//
	int i_ring;
	RING* ring;
	int ring_x;
	int ring_y;

	if(!(player->stat & HT)) { /* 蔻薳 */
		return;
	}

	get_xy(player->col, player->row, player->dir, player->pos, &player_x, &player_y);

	for(i_ring = 0; i_ring < RING_MAX; i_ring++) {
		ring = &game.ring[i_ring];
		if(!(ring->active)) { /*  */
			continue;
		}

		get_xy(ring->col, ring->row, ring->dir, ring->pos, &ring_x, &ring_y);

		if((abs(ring_x - player_x) < HT_SIZE) &&
		   (abs(ring_y - player_y) < HT_SIZE)) {
			if(!opt_invincible) {
				player_set_stat(PLAYER_STAT_DIE);
				return; /* ܂ */
			}
		}
	}
}

#undef HT_SIZE

/****************************************************************************
 *	ht_trap_player
 ****************************************************************************/

#define HT_SIZE (CELL_SIZE / 2) /*  */

void
ht_trap_player()
{
	PLAYER* player = &game.player;
	int player_x;
	int player_y;
	//
	int col;
	int row;
	CELL* cell;
	int trap_x;
	int trap_y;

	if(!(player->stat & HT)) { /* 蔻薳 */
		return;
	}

	get_xy(player->col, player->row, player->dir, player->pos, &player_x, &player_y);

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(cell->stat != CELL_STAT_TRAP) { /* 㩂 */
				continue;
			}

			get_xy(col, row, 0, 0, &trap_x, &trap_y);

			if((abs(trap_x - player_x) < HT_SIZE) &&
			   (abs(trap_y - player_y) < HT_SIZE)) {
				if(!opt_invincible) {
					player_set_stat(PLAYER_STAT_DIE);
					return; /* ܂ */
				}
			}
		}
	}
}

#undef HT_SIZE

/****************************************************************************
 *	ht_enemy_player
 ****************************************************************************/

#define HT_SIZE (CELL_SIZE / 2) /*  */

void
ht_enemy_player()
{
	PLAYER* player = &game.player;
	int player_x;
	int player_y;
	//
	int i_enemy;
	ENEMY* enemy;
	int enemy_x;
	int enemy_y;

	if(!(player->stat & HT)) { /* 蔻薳 */
		return;
	}

	get_xy(player->col, player->row, player->dir, player->pos, &player_x, &player_y);

	for(i_enemy = 0; i_enemy < ENEMY_MAX; i_enemy++) {
		enemy = &game.enemy[i_enemy];
		if(!(enemy->stat & HT)) { /* 蔻薳 */
			continue;
		}

		get_xy(enemy->col, enemy->row, enemy->dir, enemy->pos, &enemy_x, &enemy_y);

		if((abs(enemy_x - player_x) < HT_SIZE) &&
		   (abs(enemy_y - player_y) < HT_SIZE)) {

			/* ̉Ȃ... (AM^[()͒~݂̂Ȃ̂ŁAO) */
			if(enemy->weak &&
			  (enemy->type != ENEMY_TYPE_GUITARO)) {
				enemy_set_stat(enemy, ENEMY_STAT_PTS);
				sound(SND_ENEMY_OUT);
				/*{{xɂGXRA*/
				if(game.stop_pts < 200) {
					game.stop_pts = 200; /* 1C    (200) */
				} else if(game.stop_pts < 3200) {
					game.stop_pts *= 2;  /* 2`6C (400,800,1600,3200,3200) */
				}
				enemy->pts = game.stop_pts;
				score_add(enemy->pts);
				/*}}xɂGXRA*/

			/* ̉łȂ... */
			} else {
				if(!opt_invincible) {
					player_set_stat(PLAYER_STAT_DIE);
					return; /* ܂ */
				}
			}
		}
	}
}

#undef HT_SIZE

