#ifndef __SPR_H__
#define __SPR_H__
#define SPR_(name,y,x) SPR_##name = ((y)<<4|(x)),
enum {

/*  */
SPR_(ROAD,		 0, 0)		/* ړs @@@@@@ */
SPR_(ROAD_Lxxx,		 0, 1)		/* ړ\ @@@ */
SPR_(ROAD_xRxx,		 0, 2)		/* ړ\ @E@@ */
SPR_(ROAD_LRxx,		 0, 3)		/* ړ\ E@@ */
SPR_(ROAD_xxUx,		 0, 4)		/* ړ\ @@@ */
SPR_(ROAD_LxUx,		 0, 5)		/* ړ\ @@ */
SPR_(ROAD_xRUx,		 0, 6)		/* ړ\ @E@ */
SPR_(ROAD_LRUx,		 0, 7)		/* ړ\ E@ */
SPR_(ROAD_xxxD,		 0, 8)		/* ړ\ @@@ */
SPR_(ROAD_LxxD,		 0, 9)		/* ړ\ @@ */
SPR_(ROAD_xRxD,		 0,10)		/* ړ\ @E@ */
SPR_(ROAD_LRxD,		 0,11)		/* ړ\ E@ */
SPR_(ROAD_xxUD,		 0,12)		/* ړ\ @@㉺ */
SPR_(ROAD_LxUD,		 0,13)		/* ړ\ @㉺ */
SPR_(ROAD_xRUD,		 0,14)		/* ړ\ @E㉺ */
SPR_(ROAD_LRUD,		 0,15)		/* ړ\ E㉺ */

/*  +  */
SPR_(NOTE,		 1, 0)		/* ړs @@@@@@ */
SPR_(NOTE_Lxxx,		 1, 1)		/* ړ\ @@@ */
SPR_(NOTE_xRxx,		 1, 2)		/* ړ\ @E@@ */
SPR_(NOTE_LRxx,		 1, 3)		/* ړ\ E@@ */
SPR_(NOTE_xxUx,		 1, 4)		/* ړ\ @@@ */
SPR_(NOTE_LxUx,		 1, 5)		/* ړ\ @@ */
SPR_(NOTE_xRUx,		 1, 6)		/* ړ\ @E@ */
SPR_(NOTE_LRUx,		 1, 7)		/* ړ\ E@ */
SPR_(NOTE_xxxD,		 1, 8)		/* ړ\ @@@ */
SPR_(NOTE_LxxD,		 1, 9)		/* ړ\ @@ */
SPR_(NOTE_xRxD,		 1,10)		/* ړ\ @E@ */
SPR_(NOTE_LRxD,		 1,11)		/* ړ\ E@ */
SPR_(NOTE_xxUD,		 1,12)		/* ړ\ @@㉺ */
SPR_(NOTE_LxUD,		 1,13)		/* ړ\ @㉺ */
SPR_(NOTE_xRUD,		 1,14)		/* ړ\ @E㉺ */
SPR_(NOTE_LRUD,		 1,15)		/* ړ\ E㉺ */

/*  +  */
SPR_(TRAP,		 2, 0)		/* ړs @@@@@@ */
SPR_(TRAP_Lxxx,		 2, 1)		/* ړ\ @@@ */
SPR_(TRAP_xRxx,		 2, 2)		/* ړ\ @E@@ */
SPR_(TRAP_LRxx,		 2, 3)		/* ړ\ E@@ */
SPR_(TRAP_xxUx,		 2, 4)		/* ړ\ @@@ */
SPR_(TRAP_LxUx,		 2, 5)		/* ړ\ @@ */
SPR_(TRAP_xRUx,		 2, 6)		/* ړ\ @E@ */
SPR_(TRAP_LRUx,		 2, 7)		/* ړ\ E@ */
SPR_(TRAP_xxxD,		 2, 8)		/* ړ\ @@@ */
SPR_(TRAP_LxxD,		 2, 9)		/* ړ\ @@ */
SPR_(TRAP_xRxD,		 2,10)		/* ړ\ @E@ */
SPR_(TRAP_LRxD,		 2,11)		/* ړ\ E@ */
SPR_(TRAP_xxUD,		 2,12)		/* ړ\ @@㉺ */
SPR_(TRAP_LxUD,		 2,13)		/* ړ\ @㉺ */
SPR_(TRAP_xRUD,		 2,14)		/* ړ\ @E㉺ */
SPR_(TRAP_LRUD,		 2,15)		/* ړ\ E㉺ */

/* x */
SPR_(STOP,		 3, 0)		/* ʏ@@ @ */
SPR_(STOP_L,		 3, 1)		/* z  */
SPR_(STOP_R,		 3, 2)		/* z E */
SPR_(STOP_U,		 3, 3)		/* z  */
SPR_(STOP_D,		 3, 4)		/* z  */

/* GNXg */
SPR_(EXTRA,		 4, 0)		/* ʏ@@ @ */
SPR_(EXTRA_L,		 4, 1)		/* z  */
SPR_(EXTRA_R,		 4, 2)		/* z E */
SPR_(EXTRA_U,		 4, 3)		/* z  */
SPR_(EXTRA_D,		 4, 4)		/* z  */

/* xAGNXg */
SPR_(ERASE_1,		 5, 0)		/* p^[1 */
SPR_(ERASE_2,		 5, 1)		/* p^[2 */

/* ^Cg */
SPR_(TITLE,		 3, 6)		/* 10~3 */

/* c@ */
SPR_(LIFE_0,		 6, 0)		/* c@0 */
SPR_(LIFE_1,		 6, 1)		/* c@0 */
SPR_(LIFE_2,		 6, 2)		/* c@0 */
SPR_(LIFE_3,		 6, 3)		/* c@0 */
SPR_(LIFE_4,		 6, 4)		/* c@0 */
SPR_(LIFE_5,		 6, 5)		/* c@0 */
SPR_(LIFE_6,		 6, 6)		/* c@0 */
SPR_(LIFE_7,		 6, 7)		/* c@0 */
SPR_(LIFE_8,		 6, 8)		/* c@0 */
SPR_(LIFE_9,		 6, 9)		/* c@0 */

/* "PATTERN NOxxSTART" */
SPR_(START,		 7,  0)		/* 14x1 */

/* bp */
SPR_(LAPAPA_L1,		 8, 0)		/* p^[1(ړ)  */
SPR_(LAPAPA_R1,		 8, 1)		/* p^[1(ړ) E */
SPR_(LAPAPA_U1,		 8, 2)		/* p^[1(ړ)  */
SPR_(LAPAPA_D1,		 8, 3)		/* p^[1(ړ)  */
SPR_(LAPAPA_L2,		 9, 0)		/* p^[2(ړ)  */
SPR_(LAPAPA_R2,		 9, 1)		/* p^[2(ړ) E */
SPR_(LAPAPA_U2,		 9, 2)		/* p^[2(ړ)  */
SPR_(LAPAPA_D2,		 9, 3)		/* p^[2(ړ)  */
SPR_(LAPAPA_L3,		10, 0)		/* p^[3()  */
SPR_(LAPAPA_R3,		10, 1)		/* p^[3() E */
SPR_(LAPAPA_U3,		10, 2)		/* p^[3()  */
SPR_(LAPAPA_D3,		10, 3)		/* p^[3()  */
SPR_(LAPAPA_L4,		11, 0)		/* p^[4()  */
SPR_(LAPAPA_R4,		11, 1)		/* p^[4() E */
SPR_(LAPAPA_U4,		11, 2)		/* p^[4()  */
SPR_(LAPAPA_D4,		11, 3)		/* p^[4()  */
SPR_(LAPAPA_L5,		12, 0)		/* p^[5()  */
SPR_(LAPAPA_R5,		12, 1)		/* p^[5() E */
SPR_(LAPAPA_U5,		12, 2)		/* p^[5()  */
SPR_(LAPAPA_D5,		12, 3)		/* p^[5()  */
SPR_(LAPAPA_L6,		13, 0)		/* p^[6()  */
SPR_(LAPAPA_R6,		13, 1)		/* p^[6() E */
SPR_(LAPAPA_U6,		13, 2)		/* p^[6()  */
SPR_(LAPAPA_D6,		13, 3)		/* p^[6()  */

/* M^[() */
SPR_(GUITACO_L1,	 8, 4)		/* p^[1(ړ)  */
SPR_(GUITACO_R1,	 8, 5)		/* p^[1(ړ) E */
SPR_(GUITACO_U1,	 8, 6)		/* p^[1(ړ)  */
SPR_(GUITACO_D1,	 8, 7)		/* p^[1(ړ)  */
SPR_(GUITACO_L2,	 9, 4)		/* p^[2(ړ)  */
SPR_(GUITACO_R2,	 9, 5)		/* p^[2(ړ) E */
SPR_(GUITACO_U2,	 9, 6)		/* p^[2(ړ)  */
SPR_(GUITACO_D2,	 9, 7)		/* p^[2(ړ)  */

/* M^[() */
SPR_(GUITARO_L1,	 8, 8)		/* p^[1(ړ)  */
SPR_(GUITARO_R1,	 8, 9)		/* p^[1(ړ) E */
SPR_(GUITARO_U1,	 8,10)		/* p^[1(ړ)  */
SPR_(GUITARO_D1,	 8,11)		/* p^[1(ړ)  */
SPR_(GUITARO_L2,	 9, 8)		/* p^[2(ړ)  */
SPR_(GUITARO_R2,	 9, 9)		/* p^[2(ړ) E */
SPR_(GUITARO_U2,	 9,10)		/* p^[2(ړ)  */
SPR_(GUITARO_D2,	 9,11)		/* p^[2(ړ)  */

/* wbhz */
SPR_(MADPHONE_L1,	10, 4)		/* p^[1(ړ)  */
SPR_(MADPHONE_R1,	10, 5)		/* p^[1(ړ) E */
SPR_(MADPHONE_U1,	10, 6)		/* p^[1(ړ)  */
SPR_(MADPHONE_D1,	10, 7)		/* p^[1(ړ)  */
SPR_(MADPHONE_L2,	11, 4)		/* p^[2(ړ)  */
SPR_(MADPHONE_R2,	11, 5)		/* p^[2(ړ) E */
SPR_(MADPHONE_U2,	11, 6)		/* p^[2(ړ)  */
SPR_(MADPHONE_D2,	11, 7)		/* p^[2(ړ)  */

/* gCAO */
SPR_(TRIEN_L1,		10, 8)		/* p^[1(ړ)  */
SPR_(TRIEN_R1,		10, 9)		/* p^[1(ړ) E */
SPR_(TRIEN_U1,		10,10)		/* p^[1(ړ)  */
SPR_(TRIEN_D1,		10,11)		/* p^[1(ړ)  */
SPR_(TRIEN_L2,		11, 8)		/* p^[2(ړ)  */
SPR_(TRIEN_R2,		11, 9)		/* p^[2(ړ) E */
SPR_(TRIEN_U2,		11,10)		/* p^[2(ړ)  */
SPR_(TRIEN_D2,		11,11)		/* p^[2(ړ)  */

/* Vo */
SPR_(CYMBOMB_L1,	12, 4)		/* p^[1(ړ)  */
SPR_(CYMBOMB_R1,	12, 5)		/* p^[1(ړ) E */
SPR_(CYMBOMB_U1,	12, 6)		/* p^[1(ړ)  */
SPR_(CYMBOMB_D1,	12, 7)		/* p^[1(ړ)  */
SPR_(CYMBOMB_L2,	13, 4)		/* p^[2(ړ)  */
SPR_(CYMBOMB_R2,	13, 5)		/* p^[2(ړ) E */
SPR_(CYMBOMB_U2,	13, 6)		/* p^[2(ړ)  */
SPR_(CYMBOMB_D2,	13, 7)		/* p^[2(ړ)  */

/* sAm */
SPR_(PIANHA_L1,		12, 8)		/* p^[1(ړ)  */
SPR_(PIANHA_R1,		12, 9)		/* p^[1(ړ) E */
SPR_(PIANHA_U1,		12,10)		/* p^[1(ړ)  */
SPR_(PIANHA_D1,		12,11)		/* p^[1(ړ)  */
SPR_(PIANHA_L2,		13, 8)		/* p^[2(ړ)  */
SPR_(PIANHA_R2,		13, 9)		/* p^[2(ړ) E */
SPR_(PIANHA_U2,		13,10)		/* p^[2(ړ)  */
SPR_(PIANHA_D2,		13,11)		/* p^[2(ړ)  */

/* Go */
SPR_(SETUP_1,		 8,12)		/* p^[1 */
SPR_(SETUP_2,		 8,13)		/* p^[2 */
SPR_(SETUP_3,		 8,14)		/* p^[3 */
SPR_(SETUP_4,		 8,15)		/* p^[4 */

/* G̉ */
SPR_(WEAK_1,		 9,12)		/* p^[1 */
SPR_(WEAK_2,		 9,13)		/* p^[2 */

/* vC[AGAEg */
SPR_(DIE_1,		 9,14)		/* p^[1 */
SPR_(DIE_2,		 9,15)		/* p^[2 */

/* U */
SPR_(FIRE,		10,12)

/* |Cg */
SPR_(PTS_50,		11,12)		/*   50 */
SPR_(PTS_100,		11,13)		/*  100 */
SPR_(PTS_200,		11,14)		/*  200 */
SPR_(PTS_300,		11,15)		/*  300 */
SPR_(PTS_400,		12,12)		/*  400 */
SPR_(PTS_600,		12,13)		/*  600 */
SPR_(PTS_800,		12,14)		/*  800 */
SPR_(PTS_1600,		12,15)		/* 1600 */
SPR_(PTS_3200,		13,12)		/* 3200 */

/*  */
SPR_(BLANK,		13,15)

};
#undef SPR_
#endif /*__SPR_H__*/
